/*************************************************
Function:		Fisheye
Description:	鱼眼类			
*************************************************/
var oFisheye = new Fisheye();
//0-PTZ 1-180展开 2-360展开 3-球fisheye
var ChannelMode = {0:{type:-1,ptzid:0}, 1:{type:3,ptzid:0}, 2:{type:2,ptzid:0}, 3:{type:0,ptzid:1}, 4:{type:0,ptzid:2}, 5:{type:0,ptzid:3}};
function Fisheye() {
    this.m_iWhichPage = 0;  //0: 预览页面, 1: 回放页面
	this.m_iFishOSDHeight = 0;  //OSD栏高度
	this.m_iWndCutWidth = 288;  //画面分割栏宽度
	this.m_hideWndTimer = -1;  //
	this.m_iDecodeMode = 0; //0:硬解, 1:软解
    this.m_bInitFinish = false;  //是否已经初始化完成
    this.m_bAnonymous = false;  //是否是匿名登录
	this.m_iMountingType = 0; //0:wall, 1:floor, 2:ceiling
	//0-单个鱼眼， 1-全景, 2-自定义单画面, 4-1全景+3PTZ, 5-1鱼眼 + 3PTZ, 7-自定义4分屏, 8-4PTZ（实时模式下）
	this.m_iWindowType = $.cookie("fishWndType")?$.cookie("fishWndType"):0; 
	this.m_szPosXml = "";
	this.m_FisheyeVersion = 2;	
}
/*************************************************
Function:		getFishInfo
Description:	是否支持鱼眼
Input:			无			
Output:			无
return:			true, false				
*************************************************/
Fisheye.prototype.getFishInfo = function () {
	var that = this;
	$.ajax({
		type: "get",
		beforeSend: function(xhr) {
			xhr.setRequestHeader("If-Modified-Since", "0");
			xhr.setRequestHeader("Authorization", "Basic " + m_szUserPwdValue);
		},
		url: m_lHttp + m_szHostName + ":" + m_lHttpPort + "/ISAPI/System/fisheye",
		async: false,
		timeout: 15000,
		success: function(xmlDoc, textStatus, xhr) {
				//0-壁装方式(法线水平)；1-地面安装(法线向上); 2-顶装方式(法线向下)
				var szType = $(xmlDoc).find("type").eq(0).text();
				if('wall' == szType) {
					that.m_iMountingType = 0;
				}else if('desktop' == szType) {
					that.m_iMountingType = 1;	
				}else {
					that.m_iMountingType = 2;	
				}
				/*var szXmlLocalConfig = m_PreviewOCX.HWP_GetLocalConfig();
				var xmlDocLocalConfig = parseXmlFromStr(szXmlLocalConfig);
				if($(xmlDocLocalConfig).find("FishEyePlaceType").eq(0).text() !== "") {
					that.m_iMountingType = parseInt($(xmlDocLocalConfig).find("FishEyePlaceType").eq(0).text(), 10);
				}*/		
		}
	});
}
/*************************************************
Function:		initFishEye
Description:	鱼眼初始化函数(回放软解用)
Input:			无			
Output:			无
return:			无				
*************************************************/
Fisheye.prototype.initFishEye = function () {
	this.getFishInfo();
	this.m_iFishOSDHeight = 25;
	this.m_iDecodeMode = 1; //软解

	HWP.SetPlayModeType(7);
	HWP.GetCaptureParam(); //获取下抓拍图片格式
	try {
		m_PreviewOCX.HWP_SetCorrectionType(this.m_iDecodeMode);
	    m_PreviewOCX.HWP_SetPlaceType(this.m_iMountingType);
	} catch(e) {}
	
	var fishWndCutHtml = "";
	fishWndCutHtml += "<div id='dvFishModeChoose' class='fishmodechoose'>";
	for (var i = 1; i <= 11; i++) {
	    fishWndCutHtml += "<div class='fishmodeeachparent'><span class='fishmodeeach' style='background-image:url(../images/fisheye/wndMode" + i + ".png)'></span></div>";
	}
	fishWndCutHtml += "</div>";
	window.parent.$("#content").append(fishWndCutHtml);
	if(this.m_iWhichPage === 1) {
	    var fishWndCutIframeHtml = "<iframe class='fishmodechooseiframe' frameborder='0' scrolling='no'></iframe>";
	    window.parent.$("#content").append(fishWndCutIframeHtml);
	}
	var that = this;
	window.parent.$("#dvFishModeChoose").hover (
		function () {
			clearTimeout(that.m_hideWndTimer);
			window.parent.$("#dvFishModeChoose").show();
		},
		function () {
			window.parent.$("#dvFishModeChoose").hide();
			if(that.m_iWhichPage === 1) {
				window.parent.$(".fishmodechooseiframe").hide();
			}
		}
	);
	$(window.parent).unload(function () {
		try {
		    oFisheye.m_szPosXml = m_PreviewOCX.HWP_FECGetBoxPosList();
			//alert(oFisheye.m_szPosXml); //test
		} catch(e) {}
		if(!g_bIsIE) {
			localStorage.setItem("fishWndType", oFisheye.m_iWindowType);
		    localStorage.setItem("fishPosXml", oFisheye.m_szPosXml);
		} else {
			$.cookie("fishWndType", oFisheye.m_iWindowType, {expires: 100, path: '/'});
			var szPosXmlCookie = "";
			var oXmlPTZPos = parseXmlFromStr(oFisheye.m_szPosXml);
			$(oXmlPTZPos).find("PointPos").each(function (i) {
			    szPosXmlCookie += $(this).find("xPoint").eq(0).text();
				szPosXmlCookie += "," + $(this).find("yPoint").eq(0).text();
				szPosXmlCookie += "," + $(this).find("zPoint").eq(0).text();//ZOOM值
				if(i < 8) {
				    szPosXmlCookie += ";"
				}
			});
		    $.cookie("fishPosXml", szPosXmlCookie, {expires: 100, path: '/'});
		}	
	});	
	window.parent.$("#dvFishModeChoose").find("span").each(function (i) {
	    if(that.m_iDecodeMode === 1) {  //软解
			if(that.m_iMountingType === 1 || that.m_iMountingType === 2) {
			    if(i === 4 || i === 6 || i === 9) {
				    $(this).parent(".fishmodeeachparent").hide();
				}
				that.m_iWndCutWidth = 210;
			} else {
			    if(i === 3) {
				   $(this).parent(".fishmodeeachparent").hide();
				}
				that.m_iWndCutWidth = 262;
			}
		} else {  //硬解
		    
		}																	 
		$(this).bind("click", function () {		
			if(that.m_iWhichPage === 0) {
				if(m_bChannelRecord) {			
					var bWarning = confirm(getNodeValue("stoprecord") + "?");
					if(!bWarning) {
						return;
					}
				}
			} else {
				if(m_bWndRecord) {			
					var bWarning = confirm(getNodeValue("stoprecord") + "?");
					if(!bWarning) {
						return;
					}
				}			
			}		
			window.parent.$("#dvFishModeChoose").find("span").each(function (j) {
			    if ($(this).parent().css("background-color") !== "#e7e7e7") {
					$(this).parent().css("background-color", "#e7e7e7");
			        $(this).attr("style", "background-image:url(../images/fisheye/wndMode" + (j + 1) + ".png); _background-image: none; _filter:progid:DXImageTransform.Microsoft.AlphaImageLoader(src='../images/fisheye/wndMode" + (j + 1) + ".png' ,sizingMethod='crop');");					
				}
			});
			$(this).parent().css("background-color", "#892525");
			$(this).attr("style", "background-image:url(../images/fisheye/wndMode" + (i + 1) + "_sel.png); _background-image: none; _filter:progid:DXImageTransform.Microsoft.AlphaImageLoader(src='../images/fisheye/wndMode" + (i + 1) + "_sel.png' ,sizingMethod='crop');");
			if(that.m_iWhichPage === 0) {  //预览
				if(HWP.wnds[0].isPlaying) {
					StopRealPlay();
				}
				if(!g_bIsIE) {
					if(localStorage.getItem("fishPosXml") === null) {
					    HWP.ArrangeFECWindow(i, "");
					} else {
					    HWP.ArrangeFECWindow(i, localStorage.getItem("fishPosXml"));
						localStorage.setItem("fishPosXml", "");
					}
				} else {
				    if($.cookie("fishPosXml") === null) {
					    HWP.ArrangeFECWindow(i, "");
				    } else {
						var szCookieTemp = $.cookie("fishPosXml");
						var arrPTZPos = szCookieTemp.split(";");
						var szXmlPTZPos = "<?xml version='1.0' encoding='UTF-8'?><FishBoxList>";
						for(var p = 0; p < 9; p++) {
						    szXmlPTZPos += "<PointPos><id>" + (p + 1) + "</id><xPoint>" + arrPTZPos[p].split(",")[0] + "</xPoint><yPoint>" + arrPTZPos[p].split(",")[1] + "</yPoint><zPoint>" + arrPTZPos[p].split(",")[2] + "</zPoint></PointPos>";
						}
						szXmlPTZPos += "</FishBoxList>";
						//alert(szXmlPTZPos);//test
					    HWP.ArrangeFECWindow(i, szXmlPTZPos);
					    $.cookie("fishPosXml", null);
					}
				}
				StartRealPlay(1, 0);
			} else {  //回放
			    if(HWP.wnds[0].isPlaying) {
					StopPlayBack();
				}
				if(!g_bIsIE) {
					if(localStorage.getItem("fishPosXml") === null) {
					    HWP.ArrangeFECWindow(i, "");
					} else {
					    HWP.ArrangeFECWindow(i, localStorage.getItem("fishPosXml"));
						localStorage.setItem("fishPosXml", "");
					}
				} else {
				    if($.cookie("fishPosXml") === null) {
					    HWP.ArrangeFECWindow(i, "");
				    } else {
						var szCookieTemp = $.cookie("fishPosXml");
						var arrPTZPos = szCookieTemp.split(";");
						var szXmlPTZPos = "<?xml version='1.0' encoding='UTF-8'?><FishBoxList>";
						for(var p = 0; p < 9; p++) {
						    szXmlPTZPos += "<PointPos><id>" + (p + 1) + "</id><xPoint>" + arrPTZPos[p].split(",")[0] + "</xPoint><yPoint>" + arrPTZPos[p].split(",")[1] + "</yPoint><zPoint>" + arrPTZPos[p].split(",")[2] + "</zPoint></PointPos>";
						}
						szXmlPTZPos += "</FishBoxList>";
					    HWP.ArrangeFECWindow(i, szXmlPTZPos);
					    $.cookie("fishPosXml", null);
					}
				}
                if (that.m_bInitFinish) {  //初始化完成时做切换才做回访操作
                    StartPlayBack();
                }
			}
			if(that.m_iMountingType !== 0) {
				if(i === 1 || that.m_iWindowType === 1) {
					window.parent.$("#dvFishModeChoose").hide();
				}
			}
			that.m_iWindowType = i;
			//that.simulateClick(i);
			if(that.m_iWhichPage === 0) {
				if(that.m_iMountingType !== 0) {
					autoSize();
				}
			} else {
			    if(that.m_iWindowType === 1 && that.m_iMountingType !== 0) {
					$("#main_plugin").height(288);
					$("#PreviewActiveX").height(288);
					$(".localizer").css("bottom", "288px");
					$(".timebarctl").css("bottom", "348px");
					$(".timebarctlframe").css("bottom", "348px");
				} else {
					$("#main_plugin").height(576);
					$("#PreviewActiveX").height(576);
					$(".localizer").css("bottom", "0");
					$(".timebarctl").css("bottom", "60px");
					$(".timebarctlframe").css("bottom", "60px");
				}
			}
		});
	});
	$("#dvFishMode").show();
	$("#dvFishOSD").show();
	this.getOSD();
	if(!g_bIsIE) {
		if(localStorage.getItem("fishWndType") === null) {
			$(window.parent.$("#dvFishModeChoose")).find("span").eq(0).click();
		} else {
            if(that.m_iMountingType === 1 || that.m_iMountingType === 2) {
			    if(parseInt(localStorage.getItem("fishWndType"), 10) === 4 || parseInt(localStorage.getItem("fishWndType"), 10) === 6 || parseInt(localStorage.getItem("fishWndType"), 10) === 9) {
				    $(window.parent.$("#dvFishModeChoose")).find("span").eq(0).click();
				} else {
				    $(window.parent.$("#dvFishModeChoose")).find("span").eq(parseInt(localStorage.getItem("fishWndType"), 10)).click();
				}
			} else {
			    if(parseInt(localStorage.getItem("fishWndType"), 10) === 3) {
				    $(window.parent.$("#dvFishModeChoose")).find("span").eq(0).click();
				} else {
					$(window.parent.$("#dvFishModeChoose")).find("span").eq(parseInt(localStorage.getItem("fishWndType"), 10)).click();
				}
			}			
		}
	} else {
		if($.cookie("fishWndType") === null) {
			$(window.parent.$("#dvFishModeChoose")).find("span").eq(0).click();
		} else {
            if(that.m_iMountingType === 1 || that.m_iMountingType === 2) {
			    if(parseInt($.cookie("fishWndType"), 10) === 4 || parseInt($.cookie("fishWndType"), 10) === 6 || parseInt($.cookie("fishWndType"), 10) === 9) {
				    $(window.parent.$("#dvFishModeChoose")).find("span").eq(0).click();
				} else {
				   $(window.parent.$("#dvFishModeChoose")).find("span").eq(parseInt($.cookie("fishWndType"), 10)).click();
				}
			} else {
			    if(parseInt($.cookie("fishWndType"), 10) === 3) {
				   $(window.parent.$("#dvFishModeChoose")).find("span").eq(0).click();
				} else {
					$(window.parent.$("#dvFishModeChoose")).find("span").eq(parseInt($.cookie("fishWndType"), 10)).click();
				}
			}
		}	
	}
    that.m_bInitFinish = true;
}

/*************************************************
Function:		showWndCutHW
Description:	显示鱼眼画面分割(硬解预览)
Input:			无			
Output:			无
return:			无				
*************************************************/
Fisheye.prototype.showWndCutHW = function () {
	var szRight = "0px";
	var szBottom = "0px";
	this.m_iWndCutWidth = 53;
	var iWndCutHeight = -20;	
	var iDiffrencePX = 0;
    var iRight = 171 + 36;
	if (m_iPtzMode === 0) {  //0-显示 1-隐藏
		iDiffrencePX = 234;
	} else {
		iDiffrencePX = 0;	
	}
		
	switch (m_iWndType) {  //0-自适应 1-4:3  2-16:9  3-原始尺寸
		case 0:
			if (m_iPtzMode === 1) {  //0-显示 1-隐藏
				szRight = (iRight + (704 - $("#main_plugin").width())/2 - this.m_iWndCutWidth + 20) + "px";
			} else {
				szRight = (iRight + (704 - $("#main_plugin").width())/2 - this.m_iWndCutWidth + 130) + "px";
			}
			szBottom = iWndCutHeight + "px";
			break;
		case 1:
			if (m_iPtzMode === 1) {  //ptz hide
			    szRight = (iRight - this.m_iWndCutWidth - 14) + "px";
			    szBottom = iWndCutHeight + "px";
			} else {
			    szRight = (iRight - this.m_iWndCutWidth + 205) + "px";
			    szBottom = iWndCutHeight + 2 + "px";
			}		
			break;
		case 2:
			if (m_iPtzMode === 1) {  //0-显示 1-隐藏
				szRight = (iRight - this.m_iWndCutWidth - 14) + "px";
				iWndCutHeight = -20;
				szBottom = iWndCutHeight + "px";
			} else {
				szRight = (iRight - this.m_iWndCutWidth + 205) + "px";
				iWndCutHeight = -20;
				szBottom = iWndCutHeight + "px";	
			}
			break;
		case 3:
			if (m_iPtzMode === 1) {  //0-显示 1-隐藏
				if ($("#main_plugin").width() > 704) {
					szRight = (iRight - this.m_iWndCutWidth - 19) + "px";
					szBottom = iWndCutHeight + 33 + "px";
				} else {  //小分辨率
					szRight = (iRight + (m_iContentWidth - $("#main_plugin").width())/2 - this.m_iWndCutWidth + 104) + "px";
					szBottom = (594 - $("#main_plugin").height() - 6)  + "px";
				}
			} else {
				if ($("#main_plugin").width() > 704) {
					szRight = (iRight - this.m_iWndCutWidth + 220) + "px";
					szBottom = iWndCutHeight + 33 + "px";
				} else {  //小分辨率
					szRight = (iRight + (m_iContentWidth - $("#main_plugin").width())/2 - this.m_iWndCutWidth + 104) + "px";
					szBottom = (594 - $("#main_plugin").height() - 6)  + "px";
				}	
			}
			break;
		default:
			break;
	}

	window.parent.$("#dvFishModeChoose").css({right:szRight, bottom:szBottom});
    window.parent.$("#dvFishModeChoose").show();
	clearTimeout(this.m_hideWndTimer);	
}

/*************************************************
Function:		showWndCut
Description:	显示鱼眼画面分割(回放)
Input:			无			
Output:			无
return:			无				
*************************************************/
Fisheye.prototype.showWndCut = function () {
	var szRight = "0px";
	var szBottom = "0px";
	var iWndCutHeight = -12;	
	var iDiffrencePX = 0;
	if(this.m_iWhichPage === 0) {
		if (m_iPtzMode === 0) {
			iDiffrencePX = 234;
		} else {
			iDiffrencePX = 0;	
		}
		switch (m_iWndType) {
			case 0:
				if (m_iPtzMode === 1) {
					szRight = (171 + (704 - $("#main_plugin").width())/2 - this.m_iWndCutWidth + 117) + "px";
				} else {
					szRight = (171 + (704 - $("#main_plugin").width())/2 - this.m_iWndCutWidth + iDiffrencePX) + "px";
				}
				if(oFisheye.m_iWindowType === 1 && oFisheye.m_iMountingType !== 0) {
				    var iBrowserHeight = parent.document.documentElement.clientHeight;
					if(iBrowserHeight - 257 - oFisheye.m_iFishOSDHeight > 400) {
						szBottom = iWndCutHeight + (iBrowserHeight - 257 - oFisheye.m_iFishOSDHeight)/2 + "px";
					} else {
					    szBottom = iWndCutHeight + 200 + "px";
					}
				} else {
				    szBottom = iWndCutHeight + "px";
				}
				break;
			case 1:
				szRight = (171 - this.m_iWndCutWidth + iDiffrencePX) + "px";
				szBottom = iWndCutHeight + "px";			
				break;
			case 2:
				szRight = (171 - this.m_iWndCutWidth + iDiffrencePX) + "px";
				iWndCutHeight = (m_iPtzMode === 0 ? 168 : 37);
				szBottom = iWndCutHeight + "px";			
				break;
			case 3:
				if ($("#main_plugin").width() > 704) {
					szRight = (171 - this.m_iWndCutWidth + iDiffrencePX) + "px";
					szBottom = iWndCutHeight + "px";
				} else {
					szRight = (171 + (704 - $("#main_plugin").width())/2 - this.m_iWndCutWidth + 117 * (2 - m_iPtzMode)) + "px";
					szBottom = (594 - $("#main_plugin").height() - 30)  + "px";
				}			
				break;
			default:
				break;
		}
	} else {
		if(oFisheye.m_iWindowType === 1 && oFisheye.m_iMountingType !== 0) {
		    szBottom = "356px";
		} else {
		    szBottom = "68px";
		}
		if(oFisheye.m_iMountingType !== 0) {
		    szRight = "229px";
		} else {
		   szRight = "177px"; 
		}
	}
	if(this.m_iWhichPage === 1) {
		window.parent.$(".fishmodechooseiframe").css({right:szRight, bottom:szBottom});
		window.parent.$(".fishmodechooseiframe").width(this.m_iWndCutWidth - 2);
		window.parent.$(".fishmodechooseiframe").show();
	}
	window.parent.$("#dvFishModeChoose").css({right:szRight, bottom:szBottom});
	window.parent.$("#dvFishModeChoose").show();
	clearTimeout(this.m_hideWndTimer);
}
/*************************************************
Function:		hideWndCut
Description:	隐藏鱼眼画面分割
Input:			无			
Output:			无
return:			无				
*************************************************/
Fisheye.prototype.hideWndCut = function () {
	var that = this;
	this.m_hideWndTimer = setTimeout(function () {
	    window.parent.$("#dvFishModeChoose").hide();
		if(that.m_iWhichPage === 1) {
			window.parent.$(".fishmodechooseiframe").hide();
		}		
	}, 500);
}
/*************************************************
Function:		getOSD
Description:	获取OSD时间
Input:			无			
Output:			无
return:			无				
*************************************************/
Fisheye.prototype.getOSD = function () {

	if (!HWP.wnds[0].isPlaying) {
		setTimeout(oFisheye.getOSD, 1000);
		return;
	} else {
		var iTime = m_PreviewOCX.HWP_GetOSDTime(0);	
		var date = new Date(iTime * 1000);
		var szfishOSDTime = date.Format("yyyy-MM-dd hh:mm:ss");
		if (parseInt(szfishOSDTime.substring(0, 4), 10) > 1970) {
			if ($("#laDeviceName").html() === "" && $("#spanDeviceName").css("display") !== "none") {
				oFisheye.getDeviceName();   
			}
		    $("#laFishOSD").text(szfishOSDTime);
		}
		setTimeout(oFisheye.getOSD, 1000);
	}
}
/*************************************************
Function:		getDeviceName
Description:	获取通道名称
Input:			无
Output:			无
return:			无
*************************************************/
Fisheye.prototype.getDeviceName = function (iChannel) {
	if (0 == this.m_iDecodeMode) {  //硬解不需要
        return;
    }

    var bShowName = false; //是否显示通道名称
	if(typeof iChannel == "undefined")
	{
		iChannel = 1;
	}
	$.ajax(
	{
		type: "GET",
		url: m_lHttp + m_szHostName + ":" + m_lHttpPort + "/ISAPI/Custom/SelfExt/OSD/channels/"+iChannel,
		beforeSend: function(xhr) 
		{
			xhr.setRequestHeader("If-Modified-Since", "0");
			xhr.setRequestHeader("Authorization", "Basic " + m_szUserPwdValue);
		},
		async:false,
		success: function(xmlDoc, textStatus, xhr)
		{
			var channelNameOverlay = $(xmlDoc).find('channelNameOverlay').eq(0);
			if("true" == $(channelNameOverlay).find('enabled').eq(0).text())
			{
				bShowName = true;
			}
			else
			{
				bShowName = false;
			}
		},
		error: function(xhr, textStatus, errorThrown)
		{
			bShowName = false;
		}
	});	
	
	//若不需要显示
	if(false == bShowName)
	{
		//$("#laDeviceName").hide();
		$("#spanDeviceName").hide();
		return;	
	}
	
	$.ajax({
		type: "get",
		beforeSend: function(xhr) {
			xhr.setRequestHeader("If-Modified-Since", "0");
			xhr.setRequestHeader("Authorization", "Basic " + m_szUserPwdValue);
		},
		url: m_lHttp + m_szHostName + ":" + m_lHttpPort + "/ISAPI/System/Video/inputs/channels/"+iChannel,
		async: false,
		timeout: 15000,
		success: function(xmlDoc, textStatus, xhr) {
			$("#laDeviceName").html($(xmlDoc).find('name').eq(0).text());
			if($(xmlDoc).find('name').eq(0).text() === "") {
				$("#spanDeviceName").hide();
			} else {
				$("#laDeviceName").attr("title", $("#laDeviceName").html()); //title赋值	
			}
		}
	});
}
/*************************************************
Function:		simulateClick
Description:	模拟点击鱼眼模式
Input:			index:标识鱼眼开启分屏模式类别
Output:			无
return:			无
*************************************************/
Fisheye.prototype.simulateClick = function (index, init) {
	
	if ( !(index == 0 || index == 1 || index == 2 || index == 4 || index == 5 || index == 7 || index == 8) ) {
		return;
	}
	
	this.m_iWindowType = index;
	
	if(index == 5)  //1鱼眼 + 3PTZ
	{
		hideOrigSizeBtn();  //隐藏原始尺寸按钮
		this.fishPTZMode();
	}
	else if(index == 4)  //1全景 + 3PTZ
	{
		hideOrigSizeBtn();  //隐藏原始尺寸按钮
		this.PanoramaPTZMode();
	}
	else if(index == 0)  //单鱼眼
	{
		showOrigSizeBtn();  //显示原始尺寸按钮
		this.FishEyeMode();
		if (m_iWndType == 3) {//选中的是原始比例
			originSize();
		}
	}
	else if(index == 1)  //全景
	{
		showOrigSizeBtn();  //显示原始尺寸按钮
		this.PanoramaMode();
		if (m_iWndType == 3) {//选中的是原始比例
			originSize();
		}
	}
	else if(index == 2)  //自定义单个画面
	{
		showOrigSizeBtn();  //显示原始尺寸按钮
		this.CustomiseSingleMode();
	}
	else if(index == 7)  //自定义四个画面
	{
		hideOrigSizeBtn();  //隐藏原始尺寸按钮
		this.CustomiseFourMode();
	}
	else if(index == 8) {  //实时模式下4PTZ
		hideOrigSizeBtn();  //隐藏原始尺寸按钮
		this.PTZ4Mode();
		
	}
/*	else if(index == 99)  //点了自定义则需要停止所有预览 -默认单窗口分屏
	{
		showOrigSizeBtn();  //显示原始尺寸按钮
		//默认选中单画面
		$(window.parent.$("#dvFishModeChoose")).find("span").eq(0).click();
		autoSize();   //恢复到自定义大小
	}*/
	
	//0-单个鱼眼， 1-全景, 2-自定义单画面, 4-1全景+3PTZ, 5-1鱼眼 + 3PTZ, 7-自定义4分屏, 8-4PTZ（实时模式下）
	if(index == 7 || index == 2) {
		//显示自定义分割窗口
		$("#dvFishMode").show();
		//显示通道列表
		$("#dvPreviewChannel").show();
	} else {
		$("#dvFishMode").hide();
		//隐藏通道列表
		$("#dvPreviewChannel").hide();
	}
	this.setModeSelectedStyle(index);
}
/*************************************************
Function:		新模式选中样式设置
Description:	预览界面模式选中样式设置
Input:			init 是否是初始化
Output:			无
return:			无
*************************************************/
Fisheye.prototype.setModeSelectedStyle = function (index) 
{
	$("#dvPreviewModeList li").css("background","");
	//$("#dvCustomiseMode div").css("background","");
	iWndType = index === false ? (g_bIsIE ? $.cookie("fishWndType") : localStorage.getItem("fishWndType")) : oFisheye.m_iWindowType;
	if(iWndType === null)
	{
		$("#dvPreviewModeList li[onclick=\"oFisheye.simulateClick(0)\"]").css("background","f7de77");
	}
	else
	{
		if(iWndType != 7 && iWndType != 2)
		{
			$("#dvPreviewModeList li[onclick=\"oFisheye.simulateClick("+iWndType+")\"]").css("background","#f7de77");
		}
		else
		{
			$("#dvPreviewModeList li[onclick=\"oFisheye.simulateClick(2)\"]").css("background","#f7de77");
		}
	}
}
/*************************************************
Function:		initFishEye
Description:	鱼眼初始化函数
Input:			无			
Output:			无
return:			无				
*************************************************/
Fisheye.prototype.initFishEyeNew = function()
{
	var that = this;
	this.getFishInfo();  //获取
	this.m_iFishOSDHeight = 25;
	this.m_iDecodeMode = 0; //硬解
	HWP.SetPlayModeType(7);
	HWP.GetCaptureParam(); //获取下抓拍图片格式
	
	//给鱼眼分割模式增加提示
	$("#dvPreviewModeList").find('li').eq(0).prop("title", getNodeValue('laFisheyeMode'));
	$("#dvPreviewModeList").find('li').eq(1).prop("title", getNodeValue('laPanoramaMode'));
	$("#dvPreviewModeList").find('li').eq(2).prop("title", getNodeValue('laFisheye3PTZMode'));
	$("#dvPreviewModeList").find('li').eq(3).prop("title", getNodeValue('laPanorama3PTZMode'));
	$("#dvPreviewModeList").find('li').eq(4).prop("title", getNodeValue('laPTZ4'));
	$("#dvPreviewModeList").find('li').eq(5).prop("title", getNodeValue('constantBitRateOpt23'));
	
	//添加
   var fishWndCutHtml = "";
	fishWndCutHtml += "<div id='dvFishModeChoose' class='fishmodechoose'>";
	fishWndCutHtml += "<div class='fishmodeeachparent'><span class='fishmodeeach' style='background-image:url(../images/fisheye/wndMode2.png)'></span></div>";
	fishWndCutHtml += "<div class='fishmodeeachparent'><span class='fishmodeeach' style='background-image:url(../images/fisheye/wndMode8.png)'></span></div>";
	fishWndCutHtml += "</div>";
	window.parent.$("#content").append(fishWndCutHtml);
	window.parent.$("#dvFishModeChoose").hover (
		function () {
			clearTimeout(that.m_hideWndTimer);
            window.parent.$("#dvFishModeChoose").show();
		},
		function () {
            window.parent.$("#dvFishModeChoose").hide();
		}
	);
	
	//长连接只支持http
	var szLinkURL = "http://" + m_szHostName + ":" + g_szHttpPort + "/ISAPI/PTZCtrl/channels/fisheyelink";
	var iRet = HWP.StartFishListener(szLinkURL, ("YW5vbnltb3VzOn9/f39/fw==" === m_szUserPwdValue ? "" : m_szUserPwdValue), "");  //建立鱼眼长连接
	if (iRet != 0) {
        //console.log('建立长连接失败');
	} else {
        //console.log('建立长连接成功');
    }
	
	try
	{
		m_PreviewOCX.HWP_SetCorrectionType(this.m_iDecodeMode);
	    m_PreviewOCX.HWP_SetPlaceType(this.m_iMountingType);
	}
	catch(e) {} 
	
	$(window.parent).unload(function () {
		$.cookie("fishWndType", that.m_iWindowType, {expires: 100, path: '/'});
	});
	
	//鱼眼窗口分割选择框(硬解预览) 就两个选择0-单画面 1-四画面
	window.parent.$("#dvFishModeChoose").find("span").each(function (i) {
		var iID = 0;																	
		$(this).unbind().bind("click", function () {
			window.parent.$("#dvFishModeChoose").find("span").each(function (j) {  //颜色清除，回归未选中
			    if ($(this).parent().css("background-color") !== "#e7e7e7") {
					$(this).parent().css("background-color", "#e7e7e7");
					if(j == 0) {  //单画面
						iID = 2;
					} else {
						iID = 8;  //四画面
					}
			        $(this).attr("style", "background-image:url(../images/fisheye/wndMode" + iID + ".png); _background-image: none; _filter:progid:DXImageTransform.Microsoft.AlphaImageLoader(src='../images/fisheye/wndMode" + iID + ".png' ,sizingMethod='crop');");					
				}
			});
			
			//StopAllRealPlay();  //关闭所有预览
			if(i == 0) {  //单画面
				iID = 2;
				that.simulateClick(2);
			} else {
				iID = 8;  //四画面
				that.simulateClick(7);
			}
			
			$(this).parent().css("background-color", "#892525");
			$(this).attr("style", "background-image:url(../images/fisheye/wndMode" + iID + "_sel.png); _background-image: none; _filter:progid:DXImageTransform.Microsoft.AlphaImageLoader(src='../images/fisheye/wndMode" + iID + "_sel.png' ,sizingMethod='crop');");
		});
	});
	
	var iSplitID = 2; //初始化时，默认选择第iSplitID单选
	if (that.m_iWindowType == 7) {
		iSplitID = 8;
		window.parent.$("#dvFishModeChoose").find("span").eq(1).parent().css("background-color", "#892525");
		window.parent.$("#dvFishModeChoose").find("span").eq(1).attr("style", "background-image:url(../images/fisheye/wndMode" + iSplitID + "_sel.png); _background-image: none; _filter:progid:DXImageTransform.Microsoft.AlphaImageLoader(src='../images/fisheye/wndMode" + iSplitID + "_sel.png' ,sizingMethod='crop');");
	} else {
		iSplitID = 2;
		window.parent.$("#dvFishModeChoose").find("span").eq(0).parent().css("background-color", "#892525");
		window.parent.$("#dvFishModeChoose").find("span").eq(0).attr("style","background-image:url(../images/fisheye/wndMode" + iSplitID + "_sel.png); _background-image: none; _filter:progid:DXImageTransform.Microsoft.AlphaImageLoader(src='../images/fisheye/wndMode" + iSplitID + "_sel.png' ,sizingMethod='crop');");
	}
	
	//$("#dvFishMode").show();
	$("#dvFishOSD").show();
	//this.getOSD();
	
	//0-单个鱼眼， 1-全景, 2-自定义单画面, 4-1全景+3PTZ, 5-1鱼眼 + 3PTZ, 7-自定义4分屏, 8-4PTZ（实时模式下）
	//this.simulateClick(that.m_iWindowType);
}

/*************************************************
Function:		fishPTZMode
Description:	1鱼眼3PTZ模式
Input:			无			
Output:			无
return:			无				
*************************************************/
Fisheye.prototype.fishPTZMode = function()
{
	m_bOperateChannel = true;
	StopAllRealPlay();
	$("#PreviewActiveX")[0].HWP_ArrangeWindow(2);
	
	if(!this.fish3PTZ_Play()) {  //失败
		return;	
	}
}

//开启1fisheye + 3ptz预览 （非实时模式有）
Fisheye.prototype.fish3PTZ_Play = function() {
	var bResult = true;
	bResult = StartRealPlay(3,0);  //ptz1
	if(!bResult)
	{
		return false;
	}
	bResult = StartRealPlay(1,1);  //fisheye
	if(!bResult)
	{
		StopAllRealPlay();
		return false;
	}
	bResult = StartRealPlay(4,2);  //ptz2
	if(!bResult)
	{
		StopAllRealPlay();
		return;
	}
	bResult = StartRealPlay(5,3);  //ptz3  --若手机接入，则为非PTZ
	if(!bResult)
	{
		StopAllRealPlay();
		return false;
	}
	SetFontColor(3);
	m_bOperateChannel = true;
	return true;
}

/*************************************************
Function:		PanoramaPTZMode（非实时模式有）
Description:	1全景3PTZ模式
Input:			无			
Output:			无
return:			无				
*************************************************/
Fisheye.prototype.PanoramaPTZMode = function(init)
{
	StopAllRealPlay();
	$("#PreviewActiveX")[0].HWP_ArrangeWindow(2);
	if (!this.panorama3PTZ_Play()) {
		return;	
	}
}

//开启1全景 3PTZ预览
Fisheye.prototype.panorama3PTZ_Play = function() {
	var bResult = true;
	bResult = StartRealPlay(3,0);
	if(bResult == false)
	{
		return false;
	}
	bResult = StartRealPlay(2,1);
	if(bResult == false)
	{
		StopAllRealPlay();
		return false;
	}
	bResult = StartRealPlay(4,2);
	if(bResult == false)
	{
		StopAllRealPlay();
		return false;
	}
	bResult = StartRealPlay(5,3);
	if(bResult == false)
	{
		StopAllRealPlay();
		return false;
	}
	SetFontColor(3);
	m_bOperateChannel = true;
	return true;
}

/*************************************************
Function:		PTZ4Mode
Description:	实时模式4PTZ模式
Input:			无			
Output:			无
return:			无				
*************************************************/
Fisheye.prototype.PTZ4Mode = function() {
	StopAllRealPlay();
	$("#PreviewActiveX")[0].HWP_ArrangeWindow(2);
	if (!this.PTZ4_Play()) {
		return;	
	}
}

//开启2,3,4,5通道
Fisheye.prototype.PTZ4_Play = function() {
	var bResult = true;
	bResult = StartRealPlay(2,0);
	if(bResult == false)
	{
		return false;
	}
	bResult = StartRealPlay(3,1);
	if(bResult == false)
	{
		StopAllRealPlay();
		return false;
	}
	bResult = StartRealPlay(4,2);
	if(bResult == false)
	{
		StopAllRealPlay();
		return false;
	}
	bResult = StartRealPlay(5,3);
	if(bResult == false)
	{
		StopAllRealPlay();
		return false;
	}
	SetFontColor(2);
	m_bOperateChannel = true;
	return true;
}
/*************************************************
Function:		FishEyeMode
Description:	点击单鱼眼模式
Input:			无			
Output:			无
return:			无				
*************************************************/
Fisheye.prototype.FishEyeMode = function()
{
	m_bOperateChannel = true;
	StopAllRealPlay();
	$("#PreviewActiveX")[0].HWP_ArrangeWindow(1);
	if (!this.fish_Play()) {
		return;	
	}
}

//开启单鱼眼预览
Fisheye.prototype.fish_Play = function() {
	var bResult = true;
	bResult = StartRealPlay(1,0);
	if(!bResult)
	{
		return false;
	}
	SetFontColor(1);
	m_bOperateChannel = true;
	return true;
}
/*************************************************
Function:		PanoramaMode
Description:	全景模式
Input:			无			
Output:			无
return:			无				
*************************************************/
Fisheye.prototype.PanoramaMode = function(init)
{
	m_bOperateChannel = true;
	StopAllRealPlay();
	$("#PreviewActiveX")[0].HWP_ArrangeWindow(1);
	if (!this.Panorama_Play()) {
		return;	
	}
}

//开启单全景预览
Fisheye.prototype.Panorama_Play = function() {
	var bResult = true;
	bResult = StartRealPlay(2,0);
	if(!bResult)
	{
		return false;
	}
	SetFontColor(2);
	m_bOperateChannel = true;
	return true;
}
/*************************************************
Function:		CustomiseSingleMode
Description:	自定义单屏
Input:			无			
Output:			无
return:			无				
*************************************************/
Fisheye.prototype.CustomiseSingleMode = function()
{
	StopAllRealPlay();
	$("#PreviewActiveX")[0].HWP_ArrangeWindow(1);
	SetFontColor(0);
    window.parent.$("#dvFishModeChoose").find("span").eq(0).click();
}
/*************************************************
Function:		CustomiseFourMode
Description:	自定义4屏
Input:			无			
Output:			无
return:			无				
*************************************************/
Fisheye.prototype.CustomiseFourMode = function(init)
{
	StopAllRealPlay();
	$("#PreviewActiveX")[0].HWP_ArrangeWindow(2);
	SetFontColor(0);
}
/*************************************************
Function:		setFisheyeBox
Description:	设置小方格坐标
Input:						
Output:			无
return:			无				
*************************************************/
Fisheye.prototype.setFisheyeBox = function() {
    if (this.m_bAnonymous) {  //匿名登录不需要设置小方格
        return;
    }
    var szBoxXML = "";
	if(HWP.PlayingNum() > 1 && HWP.onlineChannels([1])) {  //有鱼眼+PTZ需要设置坐标
        szBoxXML = this.GetFishBoxInfo();
		try {
			$("#PreviewActiveX")[0].HWP_SetFishBoxListInfo(szBoxXML);
		}
		catch(e)
		{}
	} else {
		try {
			$("#PreviewActiveX")[0].HWP_SetFishBoxListInfo('');
		}
		catch(e)
		{}
	}
}

/*************************************************
 Function:		GetFishBoxInfo
 Description:	获取鱼眼PTZ方格信息
 Input:
 Output:			无
 return:			无
 *************************************************/
Fisheye.prototype.GetFishBoxInfo = function() {
    var that = this;
    var szXml = "";
    $.ajax({
        type: "get",
        beforeSend: function(xhr) {
            xhr.setRequestHeader("If-Modified-Since", "0");
            xhr.setRequestHeader("Authorization", "Basic " + m_szUserPwdValue);
        },
        url: m_lHttp + m_szHostName + ":" + m_lHttpPort + "/ISAPI/PTZCtrl/channels/fisheyePTZPosition",
        async: false,
        timeout: 3000,
        success: function(xmlDoc, textStatus, xhr) {
            if ($(xmlDoc).find('FisheyePTZPosition').length > 0) {
                szXml = "<?xml version='1.0' encoding='UTF-8'?><FishBoxList>";
                var iChannelId = 0;
                var iPTZId = 1;
                var Pnode = null;
                var xPos = 0.5;
                var yPos = 0.5;
                for(var i=0;i<HWP.iWndNum;i++)
                {
                    iChannelId = HWP.wnds[i].iChannel;
                    iPTZId = ChannelMode[iChannelId].ptzid;
                    if (iPTZId <= 0) {
                        continue;
                    }
                    Pnode = $(xmlDoc).find('FisheyePTZPosition').eq(iPTZId - 1);
                    if (Pnode == null || typeof Pnode == "undefined") {
                        xPos = 0.5;
                        yPos = 0.5;
                    } else {
                        xPos = parseInt(Pnode.find('positionX').eq(0).text(),10)*0.001;
                        yPos = parseInt(Pnode.find('positionY').eq(0).text(),10)*0.001;
                    }
                    if(ChannelMode[iChannelId].type == 0 && HWP.wnds[i].isPlaying)
                    {
                        szXml += '<PointPos><id>'+ iPTZId +'</id><xPoint>'+ xPos  +'</xPoint><yPoint>' + yPos + '</yPoint><zPoint>0</zPoint></PointPos>';
                    }
                }
                szXml += "</FishBoxList>";
            }
        },
        error: function() {
            szXml = "<?xml version='1.0' encoding='UTF-8'?><FishBoxList>";
            var iChannelId = 0;
            var iPTZId = 1;
            for(var i=0;i<HWP.iWndNum;i++)
            {
                iChannelId = HWP.wnds[i].iChannel;
                iPTZId = ChannelMode[iChannelId].ptzid;
                if (iPTZId <= 0) {
                    continue;
                }
                if(ChannelMode[iChannelId].type == 0 && HWP.wnds[i].isPlaying)
                {
                    szXml += '<PointPos><id>'+ iPTZId +'</id><xPoint>0.5</xPoint><yPoint>0.5</yPoint><zPoint>0</zPoint></PointPos>';
                }
            }
            szXml += "</FishBoxList>";
        }
    });
    return szXml;
}


/*************************************************
 Function:		clearFishBoxInfo
 Description:	清除鱼眼PTZ方格信息
 Input:
 Output:			无
 return:			无
 *************************************************/
Fisheye.prototype.clearFishBoxInfo = function() {
	try {
			$("#PreviewActiveX")[0].HWP_ClearAllWndFishBoxInfo();
		}
		catch(e)
		{}	
}

/*************************************************
Function:		setFisheyeWndPty
Description:	设置窗口类型
Input:			iChannel:通道号,iWnd:窗口索引		
Output:			无
return:			无				
*************************************************/
Fisheye.prototype.setFisheyeWndPty = function(iChannel,iWnd) {  //0-PTZ 1-180展开 2-360展开 3-球fisheye
	if(typeof iChannel != "object") {
		iChannel = [iChannel];
		iWnd = [iWnd];
	}
	for(var key in iChannel) {
		try {	
			$("#PreviewActiveX")[0].HWP_SetFishWndPty(iWnd[key], ChannelMode[iChannel[key]].type, ChannelMode[iChannel[key]].ptzid);
		} catch(e) {}
	}
}