/*****************************************************
FileName: Plugin.js
Description: 插件管理类
Author: wuyang    
Date: 2011.12.27
*****************************************************/

function Plugin(iWndNum, szIP, szHttpPort, szRtspPort) {
	this.iWndNum = iWndNum; // 子窗体个数
	this.iProtocolType = 0; // 取流方式，默认为RTSP
	this.wnds = new Array(this.iWndNum);
	this.iFoundedWnd = -1;
	this.selChan = 1;  //当前选择的通道
	var that = this;
	this.szCaptureFileFormat = ""; //抓图类型 ""-jpeg, ".bmp"-bmp
	
	this.initWnds = function() {
		$.each(this.wnds, function(iWndNo) {
			that.wnds[iWndNo] = {
				isPlaying: false,
				isRecording: false,
                isEnableEZoom: false,  //是否已经开启电子放大
				isSound: false,
				iChannel: 0,
				isZoom: false,
				isPTZAuto: false,
				isSetBox: false,
				soundVolume: 0
			};
		});
	}
	this.onlineChannels = function(arrQueryChannels) {
		var bResult = -1;
		if (arguments.length !== 0) {
			if(typeof arrQueryChannels != "object")
			{
				arrQueryChannels = [arrQueryChannels];
			}
			$.each(this.wnds, function(iWndNo, wnd) {
				if (wnd.isPlaying) {
					bResult = jQuery.inArray(wnd.iChannel, arrQueryChannels);
					if(bResult != -1)
					{
						return false;
					}				
				}
			});
			return bResult == -1 ? false: true;
		}
		bResult = new Array();
		$.each(this.wnds, function(iWndNo, wnd) {
			if (wnd.isPlaying) {
				bResult.push(wnd.iChannel);
			}
		});
		return bResult;
	};
	this.isPlaying = function(iChannel) {
		var bResult = false;
		that.iFoundedWnd = -1;
		$.each(this.wnds, function(iWndNo, wnd) {
			if (wnd.isPlaying && (typeof iChannel == "undefined" || wnd.iChannel == iChannel) ) {
				bResult = true;			
				that.iFoundedWnd = iWndNo;
				return false;
			}
		});
		return bResult;
	};
	this.PlayingNum = function() {
		var iResult = 0;
		$.each(this.wnds, function(iWndNo, wnd) {
			if (wnd.isPlaying) {
				iResult ++;
			}
		});
		return iResult;
	};
	this.isSound = function() {
		var bResult = false;
		that.iFoundedWnd = -1;
		$.each(this.wnds, function(iWndNo, wnd) {
			if (wnd.isSound) {
				bResult = true;
				that.iFoundedWnd = iWndNo;
				return false;
			}
		});
		return bResult;
	};
	this.isRecording = function() {
		var bResult = false;
		that.iFoundedWnd = -1;
		$.each(this.wnds, function(iWndNo, wnd) {
			if (wnd.isRecording) {
				bResult = true;
				that.iFoundedWnd = iWndNo;
				return false;
			}
		});
		return bResult;
	};
	this.isSetBox = function() {
		var bResult = false;
		$.each(this.wnds, function(iWndNo, wnd) {
			if (wnd.isSetBox) {
				bResult = true;
				that.iFoundedWnd = iWndNo;
				return false;
			}
		});
		return bResult;
	}
	this.destory = function() {
		this.Stop();
		$("#main_plugin").empty();
	};
	this.ArrangeFECWindow = function(iWndType, szXml) {
		/*//if(iWndType == 5)
		//{
			try {
				$("#PreviewActiveX")[0].HWP_ArrangeWindow(2);
				//$("#PreviewActiveX")[0].HWP_ArrangeFECWindow(1);
				//$("#PreviewActiveX")[0].HWP_Play('rtsp://172.9.4.222:554/PSIA/streaming/channels/101', 'YWRtaW46MTIzNDU=', 0, '', '');
				//$("#PreviewActiveX")[0].HWP_Play();
				//this.MultiPlay(1,0);
				//this.MultiPlay(3,3);
				//this.MultiPlay(4,4);
			} catch (e) {}
			//return;
		//}*/
		try {
			$("#PreviewActiveX")[0].HWP_ArrangeFECWindow(iWndType, szXml);
		} catch (e) {}
	};
	this.ArrangeWindow = function(iWndType) {
		try {
			$("#PreviewActiveX")[0].HWP_ArrangeWindow(iWndType);
		} catch (e) {}
	};
	
	this.fullScreen = function() {
		try {
			$("#PreviewActiveX")[0].HWP_FullScreenDisplay(true);
		} catch (e) {}
	}
	
	//获取下抓拍图片类型
	this.GetCaptureParam = function() {
		var previewOCX = $("#PreviewActiveX")[0];
		try {
			var szLocalCfg = previewOCX.HWP_GetLocalConfig();
		} catch (e) {
			var szLocalCfg = previewOCX.GetLocalConfig();
		}
		var xmlDoc = parseXmlFromStr(szLocalCfg);
		//抓图类型
		if ($(xmlDoc).find("CaptureFileFormat").length > 0) {
			this.szCaptureFileFormat = (parseInt($(xmlDoc).find("CaptureFileFormat").eq(0).text(), 10) == 1 ? ".bmp" : "");
		}
	}
    //通道号，窗口索引，主子码流 1-主码流，2-子码流，3-三码流
	this.Play = function(iChannel, iWndNo, iStreamType) {//alert(iChannel + '|' + iWndNo)
		if (arguments.length === 0) {
			iWndNo = 0;
			iChannel = 1;
			iStreamType = 1;  //rtsp中1是主码流
		}
		if(typeof iWndNo == "undefined" && arguments.length == 1)
		{
			iWndNo = iChannel;
			iChannel = 1;
			iStreamType = 1;
		}
		if(typeof iStreamType == "undefined" && arguments.length == 2)
		{
			iStreamType = 1;
		}
		if (this.wnds[iWndNo].isPlaying) {
			return 0;
		}
		try
		{
			var previewOCX = $("#PreviewActiveX")[0];
			try {
				var szLocalCfg = previewOCX.HWP_GetLocalConfig();
			} catch (e) {
				var szLocalCfg = previewOCX.GetLocalConfig();
			}
			var xmlDoc = parseXmlFromStr(szLocalCfg);
			//播放协议
			m_iProtocolType = this.iProtocolType = parseInt(xmlDoc.documentElement.childNodes[0].childNodes[0].nodeValue); // 此全局变量暂时保留，wuyang
            var szURL = "";
            //若支持私有协议且本地协议选择为RTP OVER RTSP -TCP
            if (window.parent.g_bSupportSHTTP && 0 == m_iProtocolType) {
                var iPlayChanNum = 100;
                if (1 == iStreamType) { //主码流
                    iPlayChanNum = iChannel*100;
                } else if (2 == iStreamType) {
                    iPlayChanNum = parseInt(iChannel*100,10) + 1;
                } else {
                    iPlayChanNum = parseInt(iChannel*100,10) + 2;
                }
                szURL = "http://" + m_szHostName + ":" + szHttpPort + "/SDK/play/"+iPlayChanNum+"/004";//[能力可以得到支持那种封装]这里最后以为暂时使用RTP包
            } else {
                var iPlayChanNum = 101;
                //根据码流类型生成主子码流方案
                if (1 == iStreamType) {
                    iPlayChanNum = parseInt(iChannel*100, 10) + 1;
                } else if (2 == iStreamType) {
                    iPlayChanNum = parseInt(iChannel*100, 10) + 2;
                } else {
                    iPlayChanNum = parseInt(iChannel*100, 10) + 3;
                }
                szURL = "rtsp://" + szIP + ":" + ((this.iProtocolType === 4) ? szHttpPort : szRtspPort) + "/ISAPI/streaming/channels/" + iPlayChanNum;
            }
			var iRet = previewOCX.HWP_Play(szURL, ("YW5vbnltb3VzOn9/f39/fw==" === m_szUserPwdValue ? "" : m_szUserPwdValue), iWndNo, "", "");
			if (iRet === 0) {
				this.wnds[iWndNo].isPlaying = true;
			}
			return iRet;
		} catch (e) { return -1; }
	};
	this.Stop = function(iWndNo) {
		function Stop(iWndNo) {
			if (!that.wnds[iWndNo].isPlaying) {
				return 0;
			}
			that.wnds[iWndNo].isPlaying = false;
			that.wnds[iWndNo].isRecording = false;
			that.wnds[iWndNo].isSound = false;
			that.wnds[iWndNo].isPTZAuto = false;
			try {
				$("#PreviewActiveX")[0].HWP_StopSave(iWndNo);
				return $("#PreviewActiveX")[0].HWP_Stop(iWndNo);
			} catch (e) { return -1; }
		}
		
		if (arguments.length === 0) {
			var iRet = 0;
			$.each(this.wnds, function(iWndNo, wnd) {
				if (Stop(iWndNo) !== 0) {
					iRet = -1;
				}
			});
			return iRet;
		} else {
			return Stop(iWndNo);
		}
	};
	this.SetDrawStatus = function(bStartDraw) {
		try {
			return $("#PreviewActiveX")[0].HWP_SetDrawStatus(bStartDraw);
		} catch (e) { return -1; }
	};
	this.GetRegionInfo = function() {
		try {
			return $("#PreviewActiveX")[0].HWP_GetRegionInfo();
		} catch (e) {
			return "";
		}
	};
	this.SetRegionInfo = function(szRegionInfo) {
		try {
			return $("#PreviewActiveX")[0].HWP_SetRegionInfo(szRegionInfo);
		} catch (e) { return -1; }
	};
	this.ClearRegion = function() {
		try {
			return $("#PreviewActiveX")[0].HWP_ClearRegion();
		} catch (e) { return -1; }
	};
	this.GetTextOverlay = function() {
		try {
			return $("#PreviewActiveX")[0].HWP_GetTextOverlay();
		} catch (e) {
			return "";
		}
	};
	this.SetTextOverlay = function(szTextOverlay) {
		try {
			return $("#PreviewActiveX")[0].HWP_SetTextOverlay(szTextOverlay);
		} catch (e) { return -1; }
	};
	this.SetPlayModeType = function(iPlayMode) {
		try {
			return $("#PreviewActiveX")[0].HWP_SetPlayModeType(iPlayMode);
		} catch (e) { return -1; }
	};
	this.SetCanFullScreen = function (iMode) {
		try {
			return $("#PreviewActiveX")[0].HWP_SetCanFullScreen(iMode);
		} catch (e) {
			return -1;
		}
	};
    //添加原本抓拍机设置线和获取线接口，这里复用到越界侦测
    this.SetSnapLineInfo = function (szInfo) {
        try {
            return $("#PreviewActiveX")[0].HWP_SetSnapLineInfo(szInfo);
        } catch (e) {
            return -1;
        }
    };
    this.SetSnapPolygonInfo = function (szInfo) {
        try {
            return $("#PreviewActiveX")[0].HWP_SetSnapPolygonInfo(szInfo);
        } catch (e) {
            return -1;
        }
    };
    this.GetSnapPolygonInfo = function () {
        try {
            return $("#PreviewActiveX")[0].HWP_GetSnapPolygonInfo();
        } catch (e) {
            return "";
        }
    };
    this.GetSnapLineInfo = function () {
        try {
            return $("#PreviewActiveX")[0].HWP_GetSnapLineInfo();
        } catch (e) {
            return "";
        }
    };
    this.ClearSnapInfo = function (iMode) {
        try {
            return $("#PreviewActiveX")[0].HWP_ClearSnapInfo(iMode);
        } catch (e) {
            return -1;
        }
    };
    this.SetSnapDrawMode = function (iType) {
        try {
            return $("#PreviewActiveX")[0].HWP_SetSnapDrawMode(0, iType); //模式-1:不绘图，0-编辑线 1-矩形 2-多边形
        } catch (e) {
            return -1;
        }
    };
	this.StartFishListener = function(szURL, szAuthInfo, szExData) {
		try {
			return $("#PreviewActiveX")[0].HWP_StartFishListener(szURL, szAuthInfo, szExData);	
		} catch (e) { return -1; }
	};
	this.StopFishListener = function() {
		try {
			return $("#PreviewActiveX")[0].HWP_StopFishListener();	
		} catch (e) { return -1; }
	};
	var bOpenFileBrowsing = false; // 解决Linux下Firefox的非模态
	this.OpenFileBrowser = function(iMode, szReserve) { // iMode: 0-文件夹, 1-文件
		if (bOpenFileBrowsing) {
			return;
		}
		bOpenFileBrowsing = true;
		var szPath = null;
		try {
			szPath = $("#PreviewActiveX")[0].HWP_OpenFileBrowser(iMode, szReserve);
		} catch (e) {}
		setTimeout(function() { bOpenFileBrowsing = false; }, 10); // 解决Linux下Chrome的click记忆
		return szPath;
	};
}