// JavaScript Document
var g_bSupportLocalOutput = false;

var VideoSettings = {
	tabs: null,	// 保存VideoSettings配置页面的tabs对象引用
	beforeLeave: function(iTabIndex) {
		switch (iTabIndex) {
			case 0:
				ia(BaseVideoSettings).beforeLeave();
				break;
			case 1:
				ia(OSDSettings).beforeLeave();
				break;
			case 2:
				ia(TextOverlay).beforeLeave();
				break;
			case 3:
				ia(VideoMask).beforeLeave();
				break;
			default:
				break;
		}
	}
};

/*************************************************
Function:		BaseVideoSettings
Description:	构造函数，Singleton派生类
Input:			无			
Output:			无
return:			无				
*************************************************/
function BaseVideoSettings() {
	SingletonInheritor.implement(this);
	this.m_szVideoOutType = "BNC";
}
SingletonInheritor.declare(BaseVideoSettings);

(function() { // BaseVideoSettings implementation

	BaseVideoSettings.prototype.initCSS = function () {
		InitSlider();
		//如果是球机
		if (window.parent.g_szDeviceType != "IPCamera") {
			//显示恢复默认前端参数
			$("#dvDefault").show();

			$("#laIrisMode").attr("name", "laExposureType").html(getNodeValue("laExposureType"));
			$("#laShutter").attr("name", "laShutterLevel").html(getNodeValue("laShutterLevel"));
			$("#IrisMode").change(function () {
				//球机下日夜切换灵敏度与曝光补偿的关联关系
				if (window.parent.g_szDeviceType == "IPDome") {
					if ("auto" == this.value && "auto" == $("#DayNightFilterType").val()) {
						if (g_IsSupportDayNightLevel) {
						$("#DayToNightFilterLevel_tr").show();
					}
						if (g_IsSupportDayNightFilterTime) {
							$("#DayNightFilterTime_tr").show();
				}
					} else {
					$("#DayToNightFilterLevel_tr").hide();
						$("#DayNightFilterTime_tr").hide();
					}
				}
				if (this.value != "ShutterFirst" && this.value != "manual") {
					$("#Shutter_tr").hide();
				} else {
					if (g_bSupportShutter) {
						$("#Shutter_tr").show();
					}
				}
				if (this.value != "IrisFirst" && this.value != "manual") {
					$("#IrisLevel_tr").hide();
				} else {
					if (g_bSupportIris) {
						$("#IrisLevel_tr").show();
					}
				}
				if (this.value == "manual" || this.value == "gainFirst") {
					if (isSupportGain) {
						$("#VideoGain_tr").show();
					}
				} else {
					$("#VideoGain_tr").hide();
				}
			});
			$("#DayNightFilterType").change(function () {
				if ("auto" == this.value && "auto" == $("#IrisMode").val()) {
					if (g_IsSupportDayNightLevel) {
						$("#DayToNightFilterLevel_tr").show();
					}
					if (g_IsSupportDayNightFilterTime) {
						$("#DayNightFilterTime_tr").show();
				}
				} else {
					$("#DayToNightFilterLevel_tr").hide();
					$("#DayNightFilterTime_tr").hide();
				}
				//计划
				if (this.value == "schedule") {
					$("#dvFilterStartTime").show();
					$("#dvFilterEndTime").show();
				} else {
					$("#dvFilterStartTime").hide();
					$("#dvFilterEndTime").hide();
				}
				//事件
				if (this.value == "eventTrigger") {
					$("#dvDayOrNight").show();
				} else {
					$("#dvDayOrNight").hide();
				}
			});
			$("#selSharpnessMode").change(function () {
				if (this.value == "manual") {
					if (g_bSupportSharpness) {
						$("#Sharpness_tr").show();
					}
				} else {
					$("#Sharpness_tr").hide();
				}
				SetSharpness();
			});
		} else//非球机下不同的关联关系
		{
			//隐藏恢复默认前端参数
			$("#dvDefault").hide();
			$("#DayNightFilterType").change(function () {
				if (this.value != "auto") {
					$("#DayToNightFilterLevel_tr").hide();
					$("#DayNightFilterTime_tr").hide();
					//非自动增益有效
					/*if(isSupportGain) {
						$("#VideoGain_tr").show();
					 }*/
				} else {
					//$("#VideoGain_tr").hide();
					if (g_IsSupportDayNightLevel) {
						$("#DayToNightFilterLevel_tr").show();
					}
					if (g_IsSupportDayNightFilterTime) {
						$("#DayNightFilterTime_tr").show();
					}
				}
				//计划
				if (this.value == "schedule") {
					$("#dvFilterStartTime").show();
					$("#dvFilterEndTime").show();
				} else {
					$("#dvFilterStartTime").hide();
					$("#dvFilterEndTime").hide();
				}
				//事件
				if (this.value == "eventTrigger") {
					$("#dvDayOrNight").show();
				} else {
					$("#dvDayOrNight").hide();
				}
			});
		}
		//前端参数分类显示
		$("#dvISPParam").children("div").each(function (i) {
			$(this).attr("class", "imagetype");
			$(this).children("div").eq(0).click(function () {
				$(this).parent().siblings(".imagetype").each(function () {
					$(this).children("div").eq(0).attr("class", "imagetypetitle imageexpanded");
					$(this).children("div").eq(1).hide();
				});
				if ($(this).next(":visible").length == 0) {
					$(this).attr("class", "imagetypetitle imagecollapsed").next().show();
				} else {
					$(this).attr("class", "imagetypetitle imageexpanded").next().hide();
				}
				try {
					$.cookie("curImageTypeIndex", i);
				} catch (e) {
				}
				autoResizeIframe();
			});
		});
		//
		$("#seISPSwitchMode").change(function () {
			var szVal = $(this).val();
			if ("schedule" == szVal) {
				$("#dvISPStartTime").show();
				$("#dvISPEndTime").show();
				$("#ulSwitchTabs").show();
			} else {
				$("#dvISPStartTime").hide();
				$("#dvISPEndTime").hide();
				$("#ulSwitchTabs").hide();
			}
			setISPMode();
			switchDayOrNight();
		});
		//曝光模式选项可能超长，添加title提示
		$("#IrisMode").change(function () {
			var szSelText = $(this).find("option:selected").eq(0).text();
			var objStringTest = window.parent.$("#dvStringLenTest");
			objStringTest.html(szSelText);  //用这个来检测字符串的宽度
			if ($(this).width() < objStringTest.width()) {
				$(this).attr("title", szSelText);
			} else {
				$(this).removeAttr("title");
			}
		});
		//下拉框改变后动态调整iframe高度
		$("#taBaseVideoSettings select").change(function () {
			autoResizeIframe();
		});
	}

	BaseVideoSettings.prototype.update = function () {
		var szInfo = getNodeValue('laPlugin');
		if (checkPlugin('1', szInfo, 1, 'privacymask', 0)) {
			if (!CompareFileVersion()) {
				UpdateTips();
			}
            m_iPicinform = 1;
            setTimeout(function() {
                HWP.Stop(0);
                if (HWP.Play(m_iPicinform, 0) !== 0) {
                    alert(getNodeValue("previewfailed"));
                }
            }, 10);
		}
		if ($.browser.msie && parseInt($.browser.version, 10) == 6) {
			$("#taBaseVideoSettings select").show();
			$("#OSDFontSize").hide();
		}
		if ($("#CoverStartMapbutton").val() != getNodeValue('CoverStartMapbutton')) {
		    HWP.SetDrawStatus(false);	
		}
		$("#SaveConfigBtn").hide();
        window.parent.$("#dvErrorTips").hide().html("");
		$("#SetResultTips").html("");
		$("#taBaseVideoSettings select").not($("#taBaseVideoSettings select[class$='noempty']")).empty();
		
		var that = this;
		g_transStack.clear();
		g_transStack.push(function() {
			that.setLxd(parent.translator.getLanguageXmlDoc(["VideoSettings", "BaseVideoSettings"]));
			parent.translator.appendLanguageXmlDoc(that.getLxd(), g_lxdParamConfig);
		}, true);
		g_transStack.push(function () {
			parent.translator.translatePage(that.getLxd(), document);
		}, false);
		getISPMode(); //获取前端参数
		HWP.SetCanFullScreen(1);  //设置是否可以双击全屏
	}
	BaseVideoSettings.prototype.beforeLeave = function () {
		HWP.ClearRegion();
		HWP.SetDrawStatus(false);
		HWP.SetCanFullScreen(0);  //设置是否退出双击全屏
		$("#divBLCEdit").hide();
	}
})(); // BaseVideoSettings implementation
/*************************************************
 Function:        getLocalOutputCap
 Description:    获取本地输出能力
 Input:            无
 Output:            无
 Return:            无
 *************************************************/
function getLocalOutputCap() {
	$.ajax({
		type:"GET",
		url:m_lHttp + m_szHostName + ":" + m_lHttpPort + "/ISAPI/System/Video/outputs/channels/1/capabilities",
		beforeSend:function (xhr) {
			xhr.setRequestHeader("If-Modified-Since", "0");
			xhr.setRequestHeader("Authorization", "Basic " + m_szUserPwdValue);
		},
		async:false,
		success:function (xmlDoc, textStatus, xhr) {
			$("#seLocalOutput").empty();
			//本地输出模式模式
			var aLocalOutputMode = $(xmlDoc).find('VideoOutputChannel').eq(0).find("mode").eq(0).attr("opt").split(",");
			insertOptions2Select(aLocalOutputMode, ["open", "close", "scale", "clip"], ["laToOpen", "laClose", "ScaleOutput", "ClipOutput"], "seLocalOutput");
		}
	});
}
/*************************************************
 Function:        getLocalOutputInfo
 Description:    获取本地输出信息
 Input:            无
 Output:            无
 Return:            无
 *************************************************/
function getLocalOutputInfo() {
	$.ajax({
		type:"GET",
		url:m_lHttp + m_szHostName + ":" + m_lHttpPort + "/ISAPI/System/Video/outputs/channels/1",
		beforeSend:function (xhr) {
			xhr.setRequestHeader("If-Modified-Since", "0");
			xhr.setRequestHeader("Authorization", "Basic " + m_szUserPwdValue);
		},
		success:function (xmlDoc, textStatus, xhr) {
			$("#dvLocalOutput").show();
			g_bSupportLocalOutput = true;
			getLocalOutputCap();
			$("#seLocalOutput").val($(xmlDoc).find("mode").eq(0).text());
			setValueDelayIE6("seLocalOutput", $(xmlDoc).find('VideoOutputChannel').eq(0), "mode");
			ia(BaseVideoSettings).m_szVideoOutType = $(xmlDoc).find("type").eq(0).text();
		},
		error:function (xhr, textStatus, errorThrown) {
			g_bSupportLocalOutput = false;
		}
	});
}
/*************************************************
 Function:        setLocalOutputInfo
 Description:    设置本地输出信息
 Input:            无
 Output:            无
 Return:            无
 *************************************************/
function setLocalOutputInfo() {
	var szXml = "<?xml version='1.0' encoding='UTF-8'?><VideoOutputChannel><type>" + ia(BaseVideoSettings).m_szVideoOutType + "</type><mode>" + $("#seLocalOutput").val() + "</mode></VideoOutputChannel>";
	var xmlDoc = parseXmlFromStr(szXml);
	var szURL = m_lHttp + m_szHostName + ":" + m_lHttpPort + "/ISAPI/System/Video/outputs/channels/1";
	$.ajax({
		type:"PUT",
		url:szURL,
		data:xmlDoc,
		processData:false,
		beforeSend:function (xhr) {
			xhr.setRequestHeader("If-Modified-Since", "0");
			xhr.setRequestHeader("Authorization", "Basic " + m_szUserPwdValue);
		},
		complete:function (xhr, textStatus) {
			SaveState(xhr);
		}
	});
}
/*************************************************
Function:		OSDSettings
Description:	构造函数，Singleton派生类
Input:			无			
Output:			无
return:			无				
*************************************************/
function OSDSettings() {
	SingletonInheritor.implement(this);
}
SingletonInheritor.declare(OSDSettings);

(function() { // OSDSettings implementation

	OSDSettings.prototype.initCSS = function () {
		$("#taOSDSettings :text").addClass("text");
		$("#taOSDSettings :checkbox").addClass("checkbox");
	}

	OSDSettings.prototype.beforeLeave = function() {
		m_iPicinform = 1;
	}

	OSDSettings.prototype.update = function () {
		if ($.browser.msie && parseInt($.browser.version, 10) == 6) {
		    $("#taBaseVideoSettings select").hide();
		}
		if ($("#CoverStartMapbutton").val() != getNodeValue('CoverStartMapbutton')) {
		    HWP.SetDrawStatus(false);	
		}		
		$("#SaveConfigBtn").show();
        window.parent.$("#dvErrorTips").hide().html("");
		$("#SetResultTips").html("");
		
		m_iPicinform = 1;
		$("#picinformChannel").val(1);  //多通道下拉框复位
		
		g_transStack.clear();
		var that = this;
		g_transStack.push(function() {
			that.setLxd(parent.translator.getLanguageXmlDoc(["VideoSettings", "OSDSettings"]));
			parent.translator.appendLanguageXmlDoc(that.getLxd(), g_lxdParamConfig);
		}, true);
		RecordDisplayInit();
		g_transStack.push(function() {
			parent.translator.translatePage(that.getLxd(), document);
		}, true);
		//自适应高度
		autoResizeIframe();
	}
	
	OSDSettings.prototype.submit = function(iChannel) {
		if(typeof iChannel == "undefined")
		{
			iChannel = m_iPicinform;
		}
		if(!CheckDeviceName($("#ChannelName").val(),'SetResultTips',1, false)) 	{
			$("#ChannelName").focus();
			return;
		}
		if ($("#IsShowChanNme")[0].checked) {
			SetChannelName(iChannel);
		}			
		SetOSDInfoAll(iChannel);
	}
	
	OSDSettings.prototype.beforeLeave = function() {	
		var szTextOverlay = HWP.GetTextOverlay();
		if (szTextOverlay ==="") {
			return;
		}
		var xmlDoc = parseXmlFromStr(szTextOverlay);
		try {
			xmlDoc.documentElement.getElementsByTagName('channelNameOverlay')[0].getElementsByTagName('enabled')[0].childNodes[0].nodeValue = "false";
			xmlDoc.documentElement.getElementsByTagName('DateTimeOverlay')[0].getElementsByTagName('enabled')[0].childNodes[0].nodeValue = "false";
		} catch (e) {
			return;
		}
		HWP.SetTextOverlay(xmlToStr(xmlDoc));
	}

})(); // OSDSettings implementation


/*************************************************
Function:		TextOverlay
Description:	构造函数，Singleton派生类
Input:			无			
Output:			无
return:			无				
*************************************************/
function TextOverlay() {
	SingletonInheritor.implement(this);
	this.m_arrTextX = [-1, -1, -1, -1];
	this.m_arrTextY = [-1, -1, -1, -1];
}
SingletonInheritor.declare(TextOverlay);

(function() { // TextOverlay implementation

	TextOverlay.prototype.initCSS = function()
	{
		$("#taTextOverlay :text").addClass("text");
		$("#taTextOverlay :checkbox").addClass("checkbox");
	}

	TextOverlay.prototype.update = function()
	{
		if($.browser.msie && parseInt($.browser.version, 10) == 6)
		{
		    $("#taBaseVideoSettings select").hide();
		}
        if ($("#CoverStartMapbutton").val() != getNodeValue('CoverStartMapbutton'))
		{
		    HWP.SetDrawStatus(false);	
		}		
		$("#SaveConfigBtn").show();
        window.parent.$("#dvErrorTips").hide().html("");
		$("#SetResultTips").html("");
		g_transStack.clear();
		var that = this;
		g_transStack.push(function() {
			that.setLxd(parent.translator.getLanguageXmlDoc(["VideoSettings", "TextOverlay"]));
			parent.translator.appendLanguageXmlDoc(that.getLxd(), g_lxdParamConfig);
		}, true);
		RecordOverlayInit();
		autoResizeIframe();
		g_transStack.push(function() {
			parent.translator.translatePage(that.getLxd(), document);
		}, true);
		//自适应高度
		autoResizeIframe();
	}
	
	TextOverlay.prototype.submit = function(iChannel)
	{
		if(typeof iChannel == "undefined")
		{
			iChannel = m_iPicinform;
		}
		SetOverlayInfo(iChannel);
	}

	TextOverlay.prototype.beforeLeave = function()
	{
		var szTextOverlay = HWP.GetTextOverlay();
		if (szTextOverlay ==="")
		{
			return;
		}
		var xmlDoc = parseXmlFromStr(szTextOverlay);
		try
		{
			var arrTextOverlay = xmlDoc.documentElement.getElementsByTagName('TextOverlayList')[0].getElementsByTagName("TextOverlay");
			for (var i = 0, len = arrTextOverlay.length; i != len; ++i)
			{
				arrTextOverlay[i].getElementsByTagName('enabled')[0].childNodes[0].nodeValue = "false";
			}
		}
		catch (e)
		{
			return;
		}
		HWP.SetTextOverlay(xmlToStr(xmlDoc));
	}

})(); // TextOverlay implementation


/*************************************************
Function:		VideoMask
Description:	构造函数，Singleton派生类
Input:			无			
Output:			无
return:			无				
*************************************************/
function VideoMask() {
	SingletonInheritor.implement(this);
}
SingletonInheritor.declare(VideoMask);

(function() { // VideoMask implementation

	VideoMask.prototype.initCSS = function()
	{
		$("#taVideoMask :checkbox").addClass("checkbox");
		$("#taVideoMask :button").addClass("button");
	}

	VideoMask.prototype.update = function()
	{
		if($.browser.msie && parseInt($.browser.version, 10) == 6)
		{
		    $("#taBaseVideoSettings select").hide();
		}
		$("#SaveConfigBtn").show();
        window.parent.$("#dvErrorTips").hide().html("");
		$("#SetResultTips").html("");

		RecordCoverInitDay();
		//autoResizeIframe();
		
		var that = this;
		g_transStack.clear();
		g_transStack.push(function() {
			that.setLxd(parent.translator.getLanguageXmlDoc(["VideoSettings", "VideoMask"]));
			parent.translator.appendLanguageXmlDoc(that.getLxd(), g_lxdParamConfig);
			parent.translator.translatePage(that.getLxd(), document);
		}, true);
		//自适应高度
		autoResizeIframe();
	}
	
	VideoMask.prototype.submit = function(iChannel)
	{
		if(typeof iChannel == "undefined")
		{
			iChannel = m_iPicinform;
		}
		SaveCoverInfo(iChannel);
	}

	VideoMask.prototype.beforeLeave = function()
	{
		HWP.ClearRegion();
	}

})(); // VideoMask implementation
