/*************************************************
 Function:        NMSAccess
 Description:    网管参数配置
 *************************************************/
function NMSAccess() {
	this.m_bIsSupportNMSEnable = false;     //是否支持NMSEnable
	this.m_bIsSupportNMSID = false;     //是否支持NMSID
	this.m_bIsSupportNMSHeartCycle = false;     //是否支持NMSHeartCycle
}
SingletonInheritor.declare(NMSAccess);
pr(NMSAccess).update = function () {
	$("#SaveConfigBtn").show();
	window.parent.$("#dvErrorTips").hide().html("");
	$("#SetResultTips").html("");
	g_transStack.clear();
	var that = this;
	g_transStack.push(function () {
		that.setLxd(parent.translator.getLanguageXmlDoc(["Platform", "NMSAccess"]));
		parent.translator.appendLanguageXmlDoc(that.getLxd(), g_lxdParamConfig);
		parent.translator.translatePage(that.getLxd(), document);
	}, true);
	this.getInfo();
	autoResizeIframe();
}
//获取网管参数信息
NMSAccess.prototype.getInfo = function () {
	var that = this;
	$.ajax({
		type:"get",
		url:m_lHttp + m_szHostName + ":" + m_lHttpPort + "/PSIA/Custom/SelfExt/MegaPlatform/NetManagerAccess",
		timeout:15000,
		beforeSend:function (xhr) {
			xhr.setRequestHeader("If-Modified-Since", "0");
			xhr.setRequestHeader("Authorization", "Basic " + m_szUserPwdValue);
		},
		success:function (xmlDoc, textStatus, xhr) {
			if ($(xmlDoc).find("bEnaNMS").length > 0) {
				$("#dvNMSEnable").show();
				if ("true" === $(xmlDoc).find("bEnaNMS").eq(0).text()) {
					$("#NMSEnable").prop("checked", true);
				} else {
					$("#NMSEnable").prop("checked", false);
				}
				that.m_bIsSupportNMSEnable = true;
			}

			$("#ACSUrl").val($(xmlDoc).find("ACSURL").eq(0).text());
			$("#ACSUserName").val($(xmlDoc).find("ACSUsrName").eq(0).text());
			$("#ACSPassword").val(oCheckPassword.m_szDefaultPassword);
			$("#CPEUserName").val($(xmlDoc).find("CPEUsrName").eq(0).text());
			$("#CPEPassword").val(oCheckPassword.m_szDefaultPassword);

			if ($(xmlDoc).find("NMSID").length > 0) {
				$("#dvNMSID").show();
				$("#NMSID").val($(xmlDoc).find("NMSID").eq(0).text());
				that.m_bIsSupportNMSID = true;
			}

			if ($(xmlDoc).find("NMSHeartCycle").length > 0) {
				$("#dvNMSHeartCycle").show();
				$("#NMSHeartCycle").val($(xmlDoc).find("NMSHeartCycle").eq(0).text());
				$("#laNMSHeartCycleDesc").html($(xmlDoc).find("NMSHeartCycleDesc").eq(0).text());
				that.m_bIsSupportNMSHeartCycle = true;
			}

			if (that.m_bIsSupportNMSEnable) {
				that.EnableNMS();
			}
		},
		error:function (xhr, textStatus, errorThrown) {
			alert(m_szError400);
		}
	});
}
//设置网管参数信息
NMSAccess.prototype.setInfo = function () {
	var that = this;
	if (that.m_bIsSupportNMSEnable) {
		if ($("#NMSEnable").prop("checked")) {
			if (!CheackStringLenth($("#ACSUrl").val(), "ACSUrlTips", "laACSURL", 256)) {
				return;
			}
			if (!CheackStringLenth($("#ACSUserName").val(), "ACSUserNameTips", "laACSUserName", 64)) {
				return;
			}
			if (!CheackStringLenth($("#ACSPassword").val(), "ACSPasswordTips", "laACSPassword", 64)) {
				return;
			}
			if (!CheackStringLenth($("#CPEUserName").val(), "CPEUserNameTips", "laCPEUserName", 64)) {
				return;
			}
			if (!CheackStringLenth($("#CPEPassword").val(), "CPEPasswordTips", "laCPEPassword", 64)) {
				return;
			}
			if (that.m_bIsSupportNMSID) {
				if (!CheackStringLenth($("#NMSID").val(), "NMSIDTips", "laNMSID", 64)) {
					return;
				}
			}
		}
	} else {
		if (!CheackStringLenth($("#ACSUrl").val(), "ACSUrlTips", "laACSURL", 256)) {
			return;
		}
		if (!CheackStringLenth($("#ACSUserName").val(), "ACSUserNameTips", "laACSUserName", 64)) {
			return;
		}
		if (!CheackStringLenth($("#ACSPassword").val(), "ACSPasswordTips", "laACSPassword", 64)) {
			return;
		}
		if (!CheackStringLenth($("#CPEUserName").val(), "CPEUserNameTips", "laCPEUserName", 64)) {
			return;
		}
		if (!CheackStringLenth($("#CPEPassword").val(), "CPEPasswordTips", "laCPEPassword", 64)) {
			return;
		}
		if (that.m_bIsSupportNMSID) {
			if (!CheackStringLenth($("#NMSID").val(), "NMSIDTips", "laNMSID", 64)) {
				return;
			}
		}
	}

	var xmlDoc = new createxmlDoc();
	var Instruction = xmlDoc.createProcessingInstruction("xml", "version='1.0' encoding='utf-8'");
	xmlDoc.appendChild(Instruction);
	var Root = xmlDoc.createElement("NetManagerAccess");

	if (that.m_bIsSupportNMSEnable) {
		Element = xmlDoc.createElement("bEnaNMS");
		if ($("#NMSEnable").prop("checked")) {
			text = xmlDoc.createTextNode("true");
		} else {
			text = xmlDoc.createTextNode("false");
		}
		Element.appendChild(text);
		Root.appendChild(Element);
	}

	Element = xmlDoc.createElement("ACSURL");
	text = xmlDoc.createTextNode($("#ACSUrl").val());
	Element.appendChild(text);
	Root.appendChild(Element);

	Element = xmlDoc.createElement("ACSUsrName");
	text = xmlDoc.createTextNode($("#ACSUserName").val());
	Element.appendChild(text);
	Root.appendChild(Element);

	if ($("#ACSPassword").val() != oCheckPassword.m_szDefaultPassword) {
		Element = xmlDoc.createElement("ACSPasswd");
		text = xmlDoc.createTextNode($("#ACSPassword").val());
		Element.appendChild(text);
		Root.appendChild(Element);
	}

	Element = xmlDoc.createElement("CPEUsrName");
	text = xmlDoc.createTextNode($("#CPEUserName").val());
	Element.appendChild(text);
	Root.appendChild(Element);

	if ($("#CPEPassword").val() != oCheckPassword.m_szDefaultPassword) {
		Element = xmlDoc.createElement("CPEPasswd");
		text = xmlDoc.createTextNode($("#CPEPassword").val());
		Element.appendChild(text);
		Root.appendChild(Element);
	}

	if (that.m_bIsSupportNMSID) {
		Element = xmlDoc.createElement("NMSID");
		text = xmlDoc.createTextNode($("#NMSID").val());
		Element.appendChild(text);
		Root.appendChild(Element);
	}

	if (that.m_bIsSupportNMSHeartCycle) {
		Element = xmlDoc.createElement("NMSHeartCycle");
		text = xmlDoc.createTextNode($("#NMSHeartCycle").val());
		Element.appendChild(text);
		Root.appendChild(Element);
	}

	xmlDoc.appendChild(Root);
	$.ajax({
		type:"put",
		url:m_lHttp + m_szHostName + ":" + m_lHttpPort + "/PSIA/Custom/SelfExt/MegaPlatform/NetManagerAccess",
		timeout:15000,
		processData:false,
		data:xmlDoc,
		beforeSend:function (xhr) {
			xhr.setRequestHeader("If-Modified-Since", "0");
			xhr.setRequestHeader("Authorization", "Basic " + m_szUserPwdValue);
		},
		complete:function (xhr, textStatus) {
			SaveState(xhr);
		}
	});
}
//启用网管
NMSAccess.prototype.EnableNMS = function () {
	var that = this;
	if ($("#NMSEnable").prop("checked")) {
		$("#ACSUrl").prop("disabled", false);
		$("#ACSUserName").prop("disabled", false);
		$("#ACSPassword").prop("disabled", false);
		$("#CPEUserName").prop("disabled", false);
		$("#CPEPassword").prop("disabled", false);
		if (that.m_bIsSupportNMSID) {
			$("#NMSID").prop("disabled", false);
		}
		if (that.m_bIsSupportNMSHeartCycle) {
			$("#NMSHeartCycle").prop("disabled", false);
		}
	} else {
		$("#ACSUrl").prop("disabled", true);
		$("#ACSUserName").prop("disabled", true);
		$("#ACSPassword").prop("disabled", true);
		$("#CPEUserName").prop("disabled", true);
		$("#CPEPassword").prop("disabled", true);
		if (that.m_bIsSupportNMSID) {
			$("#NMSID").prop("disabled", true);
		}
		if (that.m_bIsSupportNMSHeartCycle) {
			$("#NMSHeartCycle").prop("disabled", true);
		}
	}
}
/*************************************************
 Function:        VSB
 Description:    VSB模块参数配置
 *************************************************/
function VSB() {

}
SingletonInheritor.declare(VSB);
pr(VSB).update = function () {
	$("#SaveConfigBtn").show();
	window.parent.$("#dvErrorTips").hide().html("");
	$("#SetResultTips").html("");
	g_transStack.clear();
	var that = this;
	g_transStack.push(function () {
		that.setLxd(parent.translator.getLanguageXmlDoc(["Platform", "VSB"]));
		parent.translator.appendLanguageXmlDoc(that.getLxd(), g_lxdParamConfig);
		parent.translator.translatePage(that.getLxd(), document);
	}, true);
	this.getInfo();
	autoResizeIframe();
}
//获取网管参数信息
VSB.prototype.getInfo = function () {
	//获取VSB模块参数信息
	var that = this;

	$.ajax({
		type:"get",
		url:m_lHttp + m_szHostName + ":" + m_lHttpPort + "/PSIA/Custom/SelfExt/MegaPlatform/VSB",
		timeout:15000,
		beforeSend:function (xhr) {
			xhr.setRequestHeader("If-Modified-Since", "0");
			xhr.setRequestHeader("Authorization", "Basic " + m_szUserPwdValue);
		},
		success:function (xmlDoc, textStatus, xhr) {
			if ("true" === $(xmlDoc).find("bEnaVSB").eq(0).text()) {
				$("#VSBEnable").prop("checked", true);
			} else {
				$("#VSBEnable").prop("checked", false);
			}
			$("#VSBIpAddr").val($(xmlDoc).find("VSBIpAddr").eq(0).text());
			$("#VSBPort").val($(xmlDoc).find("VSBPort").eq(0).text());
			$("#VSBStatus").val($(xmlDoc).find("VSBStatus").eq(0).text());
			that.EnableVSB();
		},
		error:function (xhr, textStatus, errorThrown) {
			alert(m_szError400);
		}
	});
}
//设置VSB模块参数信息
VSB.prototype.setInfo = function () {
	if ($("#VSBEnable").prop("checked")) {
		if (!CheckDIPadd($("#VSBIpAddr").val(), "VSBIpAddrTips", "laVSBIpAddr")) {
			return;
		}
		if (!CheackServerIDIntNum($("#VSBPort").val(), "VSBPortTips", "laVSBPort", 0, 65535)) {
			return;
		}
	}
	var xmlDoc = new createxmlDoc();
	var Instruction = xmlDoc.createProcessingInstruction("xml", "version='1.0' encoding='utf-8'");
	xmlDoc.appendChild(Instruction);
	var Root = xmlDoc.createElement("VSB");

	Element = xmlDoc.createElement("bEnaVSB");
	if ($("#VSBEnable").prop("checked")) {
		text = xmlDoc.createTextNode("true");
	} else {
		text = xmlDoc.createTextNode("false");
	}
	Element.appendChild(text);
	Root.appendChild(Element);

	Element = xmlDoc.createElement("VSBIpAddr");
	text = xmlDoc.createTextNode($("#VSBIpAddr").val());
	Element.appendChild(text);
	Root.appendChild(Element);

	Element = xmlDoc.createElement("VSBPort");
	text = xmlDoc.createTextNode($("#VSBPort").val());
	Element.appendChild(text);
	Root.appendChild(Element);

	Element = xmlDoc.createElement("VSBStatus");
	text = xmlDoc.createTextNode($("#VSBStatus").val());
	Element.appendChild(text);
	Root.appendChild(Element);

	xmlDoc.appendChild(Root);
	$.ajax({
		type:"put",
		url:m_lHttp + m_szHostName + ":" + m_lHttpPort + "/PSIA/Custom/SelfExt/MegaPlatform/VSB",
		timeout:15000,
		processData:false,
		data:xmlDoc,
		beforeSend:function (xhr) {
			xhr.setRequestHeader("If-Modified-Since", "0");
			xhr.setRequestHeader("Authorization", "Basic " + m_szUserPwdValue);
		},
		complete:function (xhr, textStatus) {
			SaveState(xhr);
		}
	});
}
//启用网管
VSB.prototype.EnableVSB = function () {
	if ($("#VSBEnable").prop("checked")) {
		$("#VSBIpAddr").prop("disabled", false);
		$("#VSBPort").prop("disabled", false);
	} else {
		$("#VSBIpAddr").prop("disabled", true);
		$("#VSBPort").prop("disabled", true);
	}
}
/*************************************************
 Function:        PlatformAccess
 Description:    平台参数配置
 *************************************************/
function PlatformAccess() {
	this.m_bIsSupportServerIpAddr = false;      //是否支持SeverIpAddr
	this.m_bIsSupportServerPort = false;	  //是否支持ServerPort
	this.m_bIsSupportServerURL = false;	  //是否支持ServerURL
	this.m_bIsSupportDomain = false;	  //是否支持DomainName
	this.m_bIsSupportPUID = false;	  //是否支持PUID
	this.m_bIsSupportRegStatus = false;	  //是否支持RegStatus
	this.m_bIsSupportPuCmdPort = false;	  //是否支持PuCmdPort
	this.m_bIsSupportRegUserName = false;	  //是否支持RegUserName
	this.m_bIsSupportRegPassword = false;      //是否支持RegPassword
	this.m_bIsSupportHeartCycle = false;	  //是否支持HeartCycle
	this.m_bIsSupportSelectChannel = false;	  //是否支持SelectChannel
	this.m_bIsSupportChannelID = false;	  //是否支持ChannelID
	this.m_bIsSupportSubStreamEnable = false;	  //是否支持SubStreamEnable
	this.m_bIsSupportPreviewMode = false;	  //是否支持PreviewMode
	this.m_bIsSupportPlaybackMode = false;	  //是否支持PlaybackMode
	this.m_bIsSupportPuNetType = false;      //是否支持PuNetType
	this.m_bIsSupportPreviewLink = false;	  //是否支持PreviewLink
	this.m_bIsSupportNATEnable = false;	  //是否支持NATEnable
	this.m_bIsSupportNatRTSPMap = false;      //是否支持NatRTSPMap
	this.m_bIsSupportNatRTPMap = false;	  //是否支持NatRTPMap
	this.m_bIsSupportNatRTCPMap = false;	  //是否支持NatRTCPMap
	this.m_bIsSupportSDKEnable = false;	  //是否支持SDKEnable
	this.m_iTotalChanNum = 0;		  //设备支持的总通道个数
	this.m_iCurSelChanNo = 0;		  //当前选中的通道号
	this.m_iSeledChanNo = 0;		  //上次选中的通道号
	this.m_iChannelNo = new Array();
	this.m_szChannelID = new Array();
	this.m_szEnableSubStream = new Array();
	for (var i = 0; i < 96; i++)    //模拟通道+IP通道
	{
		this.m_iChannelNo[i] = 0;				//通道号
		this.m_szChannelID[i] = "";				//通道ID
		this.m_szEnableSubStream[i] = "false";	//启用辅码流
	}
}
SingletonInheritor.declare(PlatformAccess);
pr(PlatformAccess).update = function () {
	$("#SaveConfigBtn").show();
	window.parent.$("#dvErrorTips").hide().html("");
	$("#SetResultTips").html("");
	g_transStack.clear();
	var that = this;
	g_transStack.push(function () {
		that.setLxd(parent.translator.getLanguageXmlDoc(["Platform", "PlatformAccess"]));
		parent.translator.appendLanguageXmlDoc(that.getLxd(), g_lxdParamConfig);
		parent.translator.translatePage(that.getLxd(), document);
	}, true);
	this.getInfo();
	autoResizeIframe();
}
/*************************************************
 Function:        getInfo
 Description:    获取平台信息
 Input:            无
 Output:            无
 return:            无
 *************************************************/
PlatformAccess.prototype.getInfo = function () {
	var that = this;
	$.ajax({
		type:"get",
		url:m_lHttp + m_szHostName + ":" + m_lHttpPort + "/PSIA/Custom/SelfExt/MegaPlatform/PlatformAccess",
		timeout:15000,
		beforeSend:function (xhr) {
			xhr.setRequestHeader("If-Modified-Since", "0");
			xhr.setRequestHeader("Authorization", "Basic " + m_szUserPwdValue);
		},
		success:function (xmlDoc, textStatus, xhr) {
			$("#spAreaTitle").html($(xmlDoc).find("platFormName").eq(0).text());
			that.m_iCurSelChanNo = 1;
			that.m_iSeledChanNo = 1;

			if ($(xmlDoc).find("serverIpAddr").length > 0) {
				$("#dvServerIpAddr").show();
				$("#ServerIpAddr").val($(xmlDoc).find("serverIpAddr").eq(0).text());
				that.m_bIsSupportServerIpAddr = true;
			}
			if ($(xmlDoc).find("serverPort").length > 0) {
				$("#dvServerPort").show();
				$("#ServerPort").val($(xmlDoc).find("serverPort").eq(0).text());
				that.m_bIsSupportServerPort = true;
			}
			if ($(xmlDoc).find("serverUrl").length > 0) {
				$("#dvServerURL").show();
				$("#ServerURL").val($(xmlDoc).find("serverUrl").eq(0).text());
				that.m_bIsSupportServerURL = true;
			}
			if ($(xmlDoc).find("domainName").length > 0) {
				$("#dvDomainName").show();
				$("#DomainName").val($(xmlDoc).find("domainName").eq(0).text());
				$("#laDomainNameDesc").html($(xmlDoc).find("domainNameDesc").eq(0).text());
				that.m_bIsSupportDomain = true;
			}
			if ($(xmlDoc).find("PUID").length > 0) {
				$("#dvPUID").show();
				$("#PUID").val($(xmlDoc).find("PUID").eq(0).text());
				$("#laPUIDDesc").html($(xmlDoc).find("PUIDDesc").eq(0).text());
				that.m_bIsSupportPUID = true;
			}
			if ($(xmlDoc).find("regStatus").length > 0) {
				$("#dvRegStatus").show();
				$("#RegStatus").val($(xmlDoc).find("regStatus").eq(0).text());
				that.m_bIsSupportRegStatus = true;
			}
			if ($(xmlDoc).find("puCmdPort").length > 0) {
				$("#dvPuCmdPort").show();
				$("#PuCmdPort").val($(xmlDoc).find("puCmdPort").eq(0).text());
				that.m_bIsSupportPuCmdPort = true;
			}
			if ($(xmlDoc).find("regUsrName").length > 0) {
				$("#dvRegUserName").show();
				$("#RegUserName").val($(xmlDoc).find("regUsrName").eq(0).text());
				$("#laRegUserNameDesc").html($(xmlDoc).find("regUsrNameDesc").eq(0).text());
				that.m_bIsSupportRegUserName = true;
			}
			if ($(xmlDoc).find("regPasswd").length > 0) {
				$("#dvRegPassword").show();
				$("#RegPassword").val($(xmlDoc).find("regPasswd").eq(0).text());
				$("#laRegPasswordDesc").html($(xmlDoc).find("regPasswdDesc").eq(0).text());
				that.m_bIsSupportRegPassword = true;
			}
			if ($(xmlDoc).find("heartCycle").length > 0) {
				$("#dvHeartCycle").show();
				$("#HeartCycle").val($(xmlDoc).find("heartCycle").eq(0).text());
				that.m_bIsSupportHeartCycle = true;
			}

			if ($(xmlDoc).find("channelNo").length > 0) {
				$("#dvSelectChannel").show();
				that.m_bIsSupportSelectChannel = true;

				if ($(xmlDoc).find("channelID").length > 0) {
					$("#dvChannelID").show();
					that.m_bIsSupportChannelID = true;
				}

				if ($(xmlDoc).find("bEnaSubPrev").length > 0) {
					$("#dvEnableSubStream").show();
					that.m_bIsSupportSubStreamEnable = true;
				}
			}
			if (that.m_bIsSupportSelectChannel) {
				$("#SelectChannel").empty();
				var szOptionChanNo = "";
				that.m_iTotalChanNum = $(xmlDoc).find("channelInfo").length;    //记下设备支持的总通道个数
				for (var i = 0; i < $(xmlDoc).find("channelInfo").length; i++) {
					that.m_iChannelNo[i] = parseInt($(xmlDoc).find("channelInfo").eq(i).find("channelNo").eq(0).text());
					szOptionChanNo += "<option value ='" + that.m_iChannelNo[i] + "'>" + that.m_iChannelNo[i] + "</option>";

					if (that.m_bIsSupportChannelID) {
						that.m_szChannelID[i] = $(xmlDoc).find("channelInfo").eq(i).find("channelID").eq(0).text();
					}
					if (that.m_bIsSupportSubStreamEnable) {
						that.m_szEnableSubStream[i] = $(xmlDoc).find("channelInfo").eq(i).find("bEnaSubPrev").eq(0).text();
					}
				}
				$(szOptionChanNo).appendTo("#SelectChannel");
			}
			if (that.m_bIsSupportSelectChannel) {
				$("#SelectChannel").val($(xmlDoc).find("channelInfo").eq(0).find("channelNo").eq(0).text());

				if (that.m_bIsSupportChannelID) {
					$("#ChannelID").val($(xmlDoc).find("channelInfo").eq(0).find("channelID").eq(0).text());
				}
				if (that.m_bIsSupportSubStreamEnable) {
					if ("true" == $(xmlDoc).find("channelInfo").eq(0).find("bEnaSubPrev").eq(0).text()) {
						$("#SubStreamEnable").prop("checked", true);
					} else {
						$("#SubStreamEnable").prop("checked", false);
					}
				}
			}

			if ($(xmlDoc).find("prevMode").length > 0) {
				$("#dvPreviewMode").show();
				$("#PreviewMode").val($(xmlDoc).find("prevMode").eq(0).text());
				that.m_bIsSupportPreviewMode = true;
			}
			if ($(xmlDoc).find("playbackMode").length > 0) {
				$("#dvPlaybackMode").show();
				$("#PlaybackMode").val($(xmlDoc).find("playbackMode").eq(0).text());
				that.m_bIsSupportPlaybackMode = true;
			}
			if ($(xmlDoc).find("puNetType").length > 0) {
				$("#dvPuNetType").show();

				$("#PuNetType").empty();
				var NetType = $(xmlDoc).find("puNetType").eq(0).attr("opt").split(",");
				var szOptionNetType = "";
				for (var i = 0; i < NetType.length; i++) {
					szOptionNetType += "<option value ='" + NetType[i] + "'>" + NetType[i] + "</option>";
				}
				$(szOptionNetType).appendTo("#PuNetType");

				$("#PuNetType").val($(xmlDoc).find("puNetType").eq(0).text());
				that.m_bIsSupportPuNetType = true;
			}
			if ($(xmlDoc).find("prevLink").length > 0) {
				$("#dvPreviewLink").show();
				$("#PreviewLink").val($(xmlDoc).find("prevLink").eq(0).text());
				$("#laPreviewLinkDesc").html($(xmlDoc).find("prevLinkDesc").eq(0).text());
				that.m_bIsSupportPreviewLink = true;
			}
			if ($(xmlDoc).find("bEnaNat").length > 0) {
				$("#dvEnableNAT").show();
				if ("true" == $(xmlDoc).find("bEnaNat").eq(0).text()) {
					$("#NATEnable").prop("checked", true);
				} else {
					$("#NATEnable").prop("checked", false);
				}
				that.m_bIsSupportNATEnable = true;
			}

			if (that.m_bIsSupportNATEnable) {   //只有支持NATEnable时才支持RTSP Port Mapping、RTP Port Mapping、RTCP Port Mapping
				if ($(xmlDoc).find("natRTSPMap").length > 0) {
					$("#dvNatRTSPMap").show();
					$("#NatRTSPMap").val($(xmlDoc).find("natRTSPMap").eq(0).text());
					that.m_bIsSupportNatRTSPMap = true;
				}

				if ($(xmlDoc).find("natRTPMap").length > 0) {
					$("#dvNatRTPMap").show();
					$("#NatRTPMap").val($(xmlDoc).find("natRTPMap").eq(0).text());
					that.m_bIsSupportNatRTPMap = true;
				}

				if ($(xmlDoc).find("natRTCPMap").length > 0) {
					$("#dvNatRTCPMap").show();
					$("#NatRTCPMap").val($(xmlDoc).find("natRTCPMap").eq(0).text());
					that.m_bIsSupportNatRTCPMap = true;
				}

				that.EnableNAT();
			}

			if ($(xmlDoc).find("bEnaSDK").length > 0) {
				$("#dvEnableSDK").show();
				if ("true" == $(xmlDoc).find("bEnaSDK").eq(0).text()) {
					$("#SDKEnable").prop("checked", true);
				} else {
					$("#SDKEnable").prop("checked", false);
				}
				that.m_bIsSupportSDKEnable = true;
			}
			//添加样式
			$("#platformAccessSettings").children("div:visible").each(function (i) {
				if ($(this).hasClass("subparamswhite") || $(this).hasClass("subparamsgray")) {
					return false;
				}
				if (i % 2 == 0) {
					$(this).attr("class", "subparamswhite");
				} else {
					$(this).attr("class", "subparamsgray");
				}
			});
		},
		error:function (xhr, textStatus, errorThrown) {
			alert(m_szError400);
		}
	});
}
/*************************************************
 Function:        setInfo
 Description:    设置平台信息
 Input:            无
 Output:            无
 Return:            无
 *************************************************/
PlatformAccess.prototype.setInfo = function () {
	var that = this;
	if (that.m_bIsSupportServerIpAddr) {
		if (!CheckDIPadd($("#ServerIpAddr").val(), 'ServerIpAddrTips', 'laServerIpAddr')) {
			return;
		}
	}
	if (that.m_bIsSupportServerPort) {
		if (!CheackServerIDIntNum($("#ServerPort").val(), 'ServerPortTips', 'laServerPort', 1, 65535)) {
			return;
		}
	}
	if (that.m_bIsSupportServerURL) {
		if (!CheackStringLenth($("#ServerURL").val(), 'ServerURLTips', 'laServerURL', 128)) {
			return;
		}
	}
	if (that.m_bIsSupportPuCmdPort) {
		if (!CheackServerIDIntNum($("#PuCmdPort").val(), 'PuCmdPortTips', 'laPuCmdPort', 1, 65535)) {
			return;
		}
	}
	if (that.m_bIsSupportChannelID) {
		if (!CheackStringLenth($("#ChannelID").val(), 'ChannelIDTips', 'laChannelID', 20)) {
			return;
		}
	}

	if (that.m_bIsSupportNATEnable) {   //支持NATEnable
		if ($("#NATEnable").prop("checked")) {
			if (that.m_bIsSupportNatRTSPMap) {
				if (!CheackServerIDIntNum($("#NatRTSPMap").val(), 'NatRTSPMapTips', 'laNatRTSPMap', 1, 65535)) {
					return;
				}
			}

			if (that.m_bIsSupportNatRTPMap) {
				if (!CheackServerIDIntNum($("#NatRTPMap").val(), 'NatRTPMapTips', 'laNatRTPMap', 1, 65535)) {
					return;
				}
			}

			if (that.m_bIsSupportNatRTCPMap) {
				if (!CheackServerIDIntNum($("#NatRTCPMap").val(), 'NatRTCPMapTips', 'laNatRTCPMap', 1, 65535)) {
					return;
				}
			}
		}
	}

	//保存当前选中通道相关信息
	if (that.m_bIsSupportSelectChannel) {
		var iSelIndex = -1;
		for (var i = 0; i < that.m_iTotalChanNum; i++) {
			if (that.m_iCurSelChanNo == that.m_iChannelNo[i]) {
				iSelIndex = i;
				break;
			}
		}

		if (that.m_bIsSupportChannelID) {
			that.m_szChannelID[iSelIndex] = $("#ChannelID").val();
		}

		if (that.m_bIsSupportSubStreamEnable) {
			if ($("#SubStreamEnable").prop("checked")) {
				that.m_szEnableSubStream[iSelIndex] = "true";
			} else {
				that.m_szEnableSubStream[iSelIndex] = "false";
			}
		}
	}

	var xmlDoc = new createxmlDoc();
	var Instruction = xmlDoc.createProcessingInstruction("xml", "version='1.0' encoding='utf-8'");
	xmlDoc.appendChild(Instruction);
	var Root = xmlDoc.createElement("PlatformAccess");

	if (that.m_bIsSupportServerIpAddr) {
		Element = xmlDoc.createElement("serverIpAddr");
		text = xmlDoc.createTextNode($("#ServerIpAddr").val());
		Element.appendChild(text);
		Root.appendChild(Element);
	}

	if (that.m_bIsSupportServerPort) {
		Element = xmlDoc.createElement("serverPort");
		text = xmlDoc.createTextNode($("#ServerPort").val());
		Element.appendChild(text);
		Root.appendChild(Element);
	}

	if (that.m_bIsSupportServerURL) {
		Element = xmlDoc.createElement("serverUrl");
		text = xmlDoc.createTextNode($("#ServerURL").val());
		Element.appendChild(text);
		Root.appendChild(Element);
	}

	if (that.m_bIsSupportDomain) {
		Element = xmlDoc.createElement("domainName");
		text = xmlDoc.createTextNode($("#DomainName").val());
		Element.appendChild(text);
		Root.appendChild(Element);
	}

	if (that.m_bIsSupportPUID) {
		Element = xmlDoc.createElement("PUID");
		text = xmlDoc.createTextNode($("#PUID").val());
		Element.appendChild(text);
		Root.appendChild(Element);
	}

	if (that.m_bIsSupportPuCmdPort) {
		Element = xmlDoc.createElement("puCmdPort");
		text = xmlDoc.createTextNode($("#PuCmdPort").val());
		Element.appendChild(text);
		Root.appendChild(Element);
	}

	if (that.m_bIsSupportRegUserName) {
		Element = xmlDoc.createElement("regUsrName");
		text = xmlDoc.createTextNode($("#RegUserName").val());
		Element.appendChild(text);
		Root.appendChild(Element);
	}

	if (that.m_bIsSupportRegPassword) {
		Element = xmlDoc.createElement("regPasswd");
		text = xmlDoc.createTextNode($("#RegPassword").val());
		Element.appendChild(text);
		Root.appendChild(Element);
	}

	if (that.m_bIsSupportHeartCycle) {
		Element = xmlDoc.createElement("heartCycle");
		text = xmlDoc.createTextNode($("#HeartCycle").val());
		Element.appendChild(text);
		Root.appendChild(Element);
	}

	if (that.m_bIsSupportSelectChannel) {
		var ChanList = xmlDoc.createElement("channelList");

		for (var i = 0; i < that.m_iTotalChanNum; i++) {
			var ChanInfo = xmlDoc.createElement("channelInfo");

			Element = xmlDoc.createElement("channelNo");
			text = xmlDoc.createTextNode(that.m_iChannelNo[i]);
			Element.appendChild(text);
			ChanInfo.appendChild(Element);

			if (that.m_bIsSupportChannelID) {
				Element = xmlDoc.createElement("channelID");
				text = xmlDoc.createTextNode(that.m_szChannelID[i]);
				Element.appendChild(text);
				ChanInfo.appendChild(Element);
			}

			if (that.m_bIsSupportSubStreamEnable) {
				Element = xmlDoc.createElement("bEnaSubPrev");
				text = xmlDoc.createTextNode(that.m_szEnableSubStream[i]);
				Element.appendChild(text);
				ChanInfo.appendChild(Element);
			}

			ChanList.appendChild(ChanInfo);
		}

		Root.appendChild(ChanList);
	}

	if (that.m_bIsSupportPreviewMode) {
		Element = xmlDoc.createElement("prevMode");
		text = xmlDoc.createTextNode($("#PreviewMode").val());
		Element.appendChild(text);
		Root.appendChild(Element);
	}

	if (that.m_bIsSupportPlaybackMode) {
		Element = xmlDoc.createElement("playbackMode");
		text = xmlDoc.createTextNode($("#PlaybackMode").val());
		Element.appendChild(text);
		Root.appendChild(Element);
	}

	if (that.m_bIsSupportPuNetType) {
		Element = xmlDoc.createElement("puNetType");
		text = xmlDoc.createTextNode($("#PuNetType").val());
		Element.appendChild(text);
		Root.appendChild(Element);
	}

	if (that.m_bIsSupportPreviewLink) {
		Element = xmlDoc.createElement("prevLink");
		text = xmlDoc.createTextNode($("#PreviewLink").val());
		Element.appendChild(text);
		Root.appendChild(Element);
	}

	if (that.m_bIsSupportNATEnable) {
		Element = xmlDoc.createElement("bEnaNat");
		if ($("#NATEnable").prop("checked")) {
			text = xmlDoc.createTextNode("true");
		} else {
			text = xmlDoc.createTextNode("false");
		}
		Element.appendChild(text);
		Root.appendChild(Element);

		if (that.m_bIsSupportNatRTSPMap) {
			Element = xmlDoc.createElement("natRTSPMap");
			text = xmlDoc.createTextNode($("#NatRTSPMap").val());
			Element.appendChild(text);
			Root.appendChild(Element);
		}

		if (that.m_bIsSupportNatRTPMap) {
			Element = xmlDoc.createElement("natRTPMap");
			text = xmlDoc.createTextNode($("#NatRTPMap").val());
			Element.appendChild(text);
			Root.appendChild(Element);
		}

		if (that.m_bIsSupportNatRTCPMap) {
			Element = xmlDoc.createElement("natRTCPMap");
			text = xmlDoc.createTextNode($("#NatRTCPMap").val());
			Element.appendChild(text);
			Root.appendChild(Element);
		}
	}

	if (that.m_bIsSupportSDKEnable) {
		Element = xmlDoc.createElement("bEnaSDK");
		if ($("#SDKEnable").prop("checked")) {
			text = xmlDoc.createTextNode("true");
		} else {
			text = xmlDoc.createTextNode("false");
		}
		Element.appendChild(text);
		Root.appendChild(Element);
	}

	xmlDoc.appendChild(Root);
	$.ajax({
		type:"put",
		url:m_lHttp + m_szHostName + ":" + m_lHttpPort + "/PSIA/Custom/SelfExt/MegaPlatform/PlatformAccess",
		timeout:15000,
		processData:false,
		data:xmlDoc,
		beforeSend:function (xhr) {
			xhr.setRequestHeader("If-Modified-Since", "0");
			xhr.setRequestHeader("Authorization", "Basic " + m_szUserPwdValue);
		},
		complete:function (xhr, textStatus) {
			SaveState(xhr);
		}
	});
}
//选择通道
PlatformAccess.prototype.changeSelectChannel = function (strSelChanNo) {
	var that = this;
	that.m_iCurSelChanNo = parseInt(strSelChanNo);

	if (that.m_iCurSelChanNo == that.m_iSeledChanNo) {
		return;
	}
	var iSelIndex = -1;   //选中项对应的数组下标值
	for (var i = 0; i < that.m_iTotalChanNum; i++) {
		if (that.m_iSeledChanNo == that.m_iChannelNo[i]) {
			iSelIndex = i;
			break;
		}
	}

	if (that.m_bIsSupportChannelID) {
		that.m_szChannelID[iSelIndex] = $("#ChannelID").val();
	}

	if (that.m_bIsSupportSubStreamEnable) {
		if ($("#SubStreamEnable").prop("checked")) {
			that.m_szEnableSubStream[iSelIndex] = "true";
		} else {
			that.m_szEnableSubStream[iSelIndex] = "false";
		}
	}

	iSelIndex = -1;
	for (var j = 0; j < that.m_iTotalChanNum; j++) {
		if (that.m_iCurSelChanNo == that.m_iChannelNo[j]) {
			iSelIndex = j;
			break;
		}
	}

	if (that.m_bIsSupportChannelID) {
		$("#ChannelID").val(that.m_szChannelID[iSelIndex]);
	}
	if (that.m_bIsSupportSubStreamEnable) {
		if ("true" == that.m_szEnableSubStream[iSelIndex]) {
			$("#SubStreamEnable").prop("checked", true);
		} else {
			$("#SubStreamEnable").prop("checked", false);
		}
	}

	that.m_iSeledChanNo = that.m_iCurSelChanNo;
}
//启用NAT
PlatformAccess.prototype.EnableNAT = function () {
	var that = this;
	if ($("#NATEnable").prop("checked")) {
		if (that.m_bIsSupportNatRTSPMap) {
			$("#NatRTSPMap").prop("disabled", false);
		}
		if (that.m_bIsSupportNatRTPMap) {
			$("#NatRTPMap").prop("disabled", false);
		}
		if (that.m_bIsSupportNatRTCPMap) {
			$("#NatRTCPMap").prop("disabled", false);
		}
	} else {
		if (that.m_bIsSupportNatRTSPMap) {
			$("#NatRTSPMap").prop("disabled", true);
		}
		if (that.m_bIsSupportNatRTPMap) {
			$("#NatRTPMap").prop("disabled", true);
		}
		if (that.m_bIsSupportNatRTCPMap) {
			$("#NatRTCPMap").prop("disabled", true);
		}
	}
}
/*************************************************
 Function:        PlatReset
 Description:    恢复平台默认参数
 *************************************************/
function PlatReset() {

}
SingletonInheritor.declare(PlatReset);
PlatReset.prototype.update = function () {
	$("#SaveConfigBtn").show();
	window.parent.$("#dvErrorTips").hide().html("");
	$("#SetResultTips").html("");
	g_transStack.clear();
	var that = this;
	g_transStack.push(function () {
		that.setLxd(parent.translator.getLanguageXmlDoc(["Platform", "PlatReset"]));
		parent.translator.appendLanguageXmlDoc(that.getLxd(), g_lxdParamConfig);
		parent.translator.translatePage(that.getLxd(), document);
	}, true);
	autoResizeIframe();
}
//恢复默认值
PlatReset.prototype.toRestoreDefault = function (szMode) {
	Warning = confirm(getNodeValue('jsPlatRestoreDefault'));
	if (!Warning) {
		return;
	}
	$.ajax({
		type:"put",
		url:m_lHttp + m_szHostName + ":" + m_lHttpPort + "/PSIA/Custom/SelfExt/MegaPlatform/PlatReset?mode=" + szMode,
		async:true,
		beforeSend:function (xhr) {
			xhr.setRequestHeader("If-Modified-Since", "0");
			xhr.setRequestHeader("Authorization", "Basic " + m_szUserPwdValue);
		},
		success:function (xmlDoc, textStatus, xhr) {
			SaveState(xhr);
		},
		error:function (xhr, textStatus, errorThrown) {
			SaveState(xhr);
		}
	});
}