/*************************************************
 Function:        VideoLostInitDay
 Description:    添加通道名称
 Input:            无
 Output:            无
 return:            无
 *************************************************/
function VideoLostInitDay() {
	CreateAlarmOutputList(g_iAlarmOutNum); 			//列出触发报警输出通道
	$("#MoveEmail").prop("checked", false);
	$("#MoveSoundAlarm").prop("checked", false);
	$("#MoveMonitorAlarm").prop("checked", false);
	$("#MoveUpload").prop("checked", false);

	GetVideoLostInfo();
}
/*************************************************
 Function:        GetVideoLostLink
 Description:    获取视频遮挡联动方式
 Input:            无
 Output:            无
 return:            无
 *************************************************/
function GetVideoLostLink() {
	var szURL = m_lHttp + m_szHostName + ":" + m_lHttpPort + "/ISAPI/Event/triggers/videoloss-1";
	$.ajax({
		type:"GET",
		url:szURL,
		beforeSend:function (xhr) {
			xhr.setRequestHeader("If-Modified-Since", "0");
			xhr.setRequestHeader("Authorization", "Basic " + m_szUserPwdValue);
		},
		success:function (xmlDoc, textStatus, xhr) {
			$("#IsUseVideoLost").prop("checked", true);
			var iMethodNum = $(xmlDoc).find("notificationMethod").length;
			for (i = 0; i < iMethodNum; i++)//报警输入联动信息
			{
				if ("email" == $(xmlDoc).find('notificationMethod').eq(i).text()) {
					$("#MoveEmail").prop("checked", true);
				}
				if ("beep" == $(xmlDoc).find('notificationMethod').eq(i).text()) {
					$("#MoveSoundAlarm").prop("checked", true);
				}
				if ("center" == $(xmlDoc).find('notificationMethod').eq(i).text()) {
					$("#MoveUpload").prop("checked", true);
				}
				if ("monitorAlarm" == $(xmlDoc).find('notificationMethod').eq(i).text()) {
					$("#MoveMonitorAlarm").prop("checked", true);
				}
			}
			var iAnalogOutPut = $(xmlDoc).find("outputIOPortID").length;
			for (j = 0; j < iAnalogOutPut; j++) {
				var iNo = $(xmlDoc).find("outputIOPortID").eq(j).text();
				for (var i = 0; i < g_iAlarmOutNum; i++) {
					if ((i+1) == iNo) {
						iNo = i;
						break;
					}
				}
				$("#AlarmOutputCheckboxChanO-" + (iNo + 1)).prop("checked", true);
			}
			CheackAlarmOutputAllSel();
		},
		error:function (xhr, textStatus, errorThrown) {
			$("#IsUseVideoLost").prop("checked", false);
		},
		complete:function () {
			EnableVideoLost();
		}
	});
}
/*************************************************
 Function:        GetVideoLostSchedule
 Description:    获取视频丢失布防时间
 Input:            无
 Output:            无
 return:            无
 *************************************************/
function GetVideoLostSchedule() {
	var szURL = m_lHttp + m_szHostName + ":" + m_lHttpPort + "/ISAPI/Event/schedules/videolosses";
	$.ajax({
		type:"GET",
		url:szURL,
		beforeSend:function (xhr) {
			xhr.setRequestHeader("If-Modified-Since", "0");
			xhr.setRequestHeader("Authorization", "Basic " + m_szUserPwdValue);
		},
		success:function (xmlDoc, textStatus, xhr) {
			//清空计划
			for (var i = 0; i < 8; i++) {
				for (var j = 0; j < 8; j++) {
					m_szWeek[i][j][0] = "00:00:00";
					m_szWeek[i][j][1] = "00:00:00";
				}
			}

			var xmlScheduleDoc = $(xmlDoc).find('Schedule').eq(0);

			if (xmlScheduleDoc != null) {
				//按能力数量隐藏和显示
				var iMaxSize = $(xmlScheduleDoc).find("TimeBlockList").eq(0).attr("size");
				if (iMaxSize != undefined) {
					iMaxSize = parseInt(iMaxSize, 10);
				} else {
					iMaxSize = 4;
				}
				var aTimeRanges = $("#TimeScheduleEdit").find(".scheduleeditdiv").eq(0).find("tr");
				for (var k = 1; k <= 8; k++) {
					if (k <= iMaxSize) {
						aTimeRanges.eq(k).show();
					} else {
						aTimeRanges.eq(k).hide();
					}
				}

				for (var i = 0; i < $(xmlScheduleDoc).find('dayOfWeek').length; i++) {
					dayofWeek = $(xmlScheduleDoc).find('dayOfWeek').eq(i).text();
					for (var j = 0; j < 8; j++) {
						if (m_szWeek[dayofWeek - 1][j][0] == '00:00:00' && m_szWeek[dayofWeek - 1][j][1] == '00:00:00') {
							m_szWeek[dayofWeek - 1][j][0] = $(xmlScheduleDoc).find('TimeRange').eq(i).children('beginTime').eq(0).text();
							m_szWeek[dayofWeek - 1][j][1] = $(xmlScheduleDoc).find('TimeRange').eq(i).children('endTime').eq(0).text();
							break;
						}
					}
				}
				if (m_bHolidayEnable) {
					for (var i = 0; i < $(xmlScheduleDoc).find('HolidayBlockList').eq(0).children('TimeBlock').length; i++) {
						for (var j = 0; j < 8; j++) {
							if ((m_szWeek[7][j][0] == '00:00:00' && m_szWeek[7][j][1] == '00:00:00') || (m_szWeek[7][j][0] != '00:00:00' && m_szWeek[7][j][1] == '00:00:00')) {
								m_szWeek[7][j][0] = $(xmlScheduleDoc).find('HolidayBlockList').eq(0).find('beginTime').eq(i).text();
								m_szWeek[7][j][1] = $(xmlScheduleDoc).find('HolidayBlockList').eq(0).find('beginTime').eq(i).text();
								break;
							}
						}
					}
				}
			}
			InitDrawSchedule();
		},
		error:function (xhr, textStatus, errorThrown) {
			return;
		}
	});
}
/*************************************************
 Function:        GetVideoLostInfo
 Description:    获取硬盘录像机的通道视频丢失参数信息
 Input:            无
 Output:            无
 Return:            无
 *************************************************/
function GetVideoLostInfo() {
	GetVideoLostLink();
	GetVideoLostSchedule();
}
/*************************************************
 Function:        SetVideoLostInfo
 Description:    设置视频丢失
 Input:            无
 Output:            无
 return:            无
 *************************************************/
function SetVideoLostInfo() {
	if ($("#IsUseVideoLost").prop("checked")) {
		SetLostLink();
	} else {
		DeleteVideoLostLink();//是否需要删除联动
	}
}
/*************************************************
 Function:        SetLostSchedule
 Description:    设置视频丢失布防时间
 Input:            无
 Output:            无
 return:            无
 *************************************************/
function SetLostSchedule() {
	var xmlDoc = CreateScheduleDoc("videoloss", "", "");
	var szURL = m_lHttp + m_szHostName + ":" + m_lHttpPort + "/ISAPI/Event/schedules/videolosses";
	$.ajax({
		type:"PUT",
		url:szURL,
		data:xmlDoc,
		async:false,
		processData:false,
		beforeSend:function (xhr) {
			xhr.setRequestHeader("If-Modified-Since", "0");
			xhr.setRequestHeader("Authorization", "Basic " + m_szUserPwdValue);
		},
		complete:function (xhr, textStatus) {
			SaveState(xhr);
		}
	});
}
/*************************************************
 Function:        SetLostLink
 Description:    设置视频丢失联动方式
 Input:            无
 Output:            无
 return:            无
 *************************************************/
function SetLostLink() {
	var xmlDoc = CreateLinkDoc("videoloss");
	var szURL = m_lHttp + m_szHostName + ":" + m_lHttpPort + "/ISAPI/Event/triggers/videoloss-1";
	$.ajax({
		type:"PUT",
		url:szURL,
		data:xmlDoc,
		async:false,
		processData:false,
		beforeSend:function (xhr) {
			xhr.setRequestHeader("If-Modified-Since", "0");
			xhr.setRequestHeader("Authorization", "Basic " + m_szUserPwdValue);
		},
		success:function (xmlDoc, textStatus, xhr) {
			SetLostSchedule();
		},
		error:function (xhr, textStatus, errorThrown) {
			SaveState(xhr);
		}
	});
}
/*************************************************
 Function:        DeleteVideoLostLink
 Description:    删除移动侦测联动
 Input:            无
 Output:            无
 return:            无
 *************************************************/
function DeleteVideoLostLink() {
	var szURL = m_lHttp + m_szHostName + ":" + m_lHttpPort + "/ISAPI/Event/triggers/videoloss-1";
	$.ajax({
		type:"DELETE",
		url:szURL,
		async:false,
		beforeSend:function (xhr) {
			xhr.setRequestHeader("If-Modified-Since", "0");
			xhr.setRequestHeader("Authorization", "Basic " + m_szUserPwdValue);
		}
	});
}